var Analytics = function(roomServer) {
    this.analyticsPath_ = roomServer + "/a/";
};
Analytics.EventObject_ = {};
Analytics.prototype.reportEvent = function(eventType, roomId, flowId) {
    var eventObj = {};
    eventObj[enums.RequestField.EventField.EVENT_TYPE] = eventType;
    eventObj[enums.RequestField.EventField.EVENT_TIME_MS] = Date.now();
    if (roomId) {
        eventObj[enums.RequestField.EventField.ROOM_ID] = roomId;
    }
    if (flowId) {
        eventObj[enums.RequestField.EventField.FLOW_ID] = flowId;
    }
    this.sendEventRequest_(eventObj);
};
Analytics.prototype.sendEventRequest_ = function(eventObj) {
    var request = {};
    request[enums.RequestField.TYPE] = enums.RequestField.MessageType.EVENT;
    request[enums.RequestField.REQUEST_TIME_MS] = Date.now();
    request[enums.RequestField.EVENT] = eventObj;
    sendAsyncUrlRequest("POST", this.analyticsPath_, JSON.stringify(request)).then(function() {
    }.bind(this), function(error) {
        trace("Failed to send event request: " + error.message);
    }.bind(this));
};
var enums = {"EventType":{"ICE_CONNECTION_STATE_CONNECTED":3, "ROOM_SIZE_2":2}, "RequestField":{"MessageType":{"EVENT":"event"}, "CLIENT_TYPE":"client_type", "EventField":{"EVENT_TIME_MS":"event_time_ms", "ROOM_ID":"room_id", "EVENT_TYPE":"event_type", "FLOW_ID":"flow_id"}, "TYPE":"type", "EVENT":"event", "REQUEST_TIME_MS":"request_time_ms"}, "ClientType":{"UNKNOWN":0, "ANDROID":4, "DESKTOP":2, "IOS":3, "JS":1}};
var getUserMedia = null;
var attachMediaStream = null;
var reattachMediaStream = null;
var webrtcDetectedBrowser = null;
var webrtcDetectedVersion = null;
var webrtcMinimumVersion = null;
var webrtcUtils = {log:function() {
    if (typeof module !== "undefined" || typeof require === "function" && typeof define === "function") {
        return;
    }
    console.log.apply(console, arguments);
}, extractVersion:function(uastring, expr, pos) {
    var match = uastring.match(expr);
    return match && match.length >= pos && parseInt(match[pos], 10);
}};
function trace(text) {
    if (text[text.length - 1] === "\n") {
        text = text.substring(0, text.length - 1);
    }
    if (window.performance) {
        var now = (window.performance.now() / 1E3).toFixed(3);
        webrtcUtils.log(now + ": " + text);
    } else {
        webrtcUtils.log(text);
    }
}
if (typeof window === "object") {
    if (window.HTMLMediaElement && !("srcObject" in window.HTMLMediaElement.prototype)) {
        Object.defineProperty(window.HTMLMediaElement.prototype, "srcObject", {get:function() {
            return "mozSrcObject" in this ? this.mozSrcObject : this._srcObject;
        }, set:function(stream) {
            if ("mozSrcObject" in this) {
                this.mozSrcObject = stream;
            } else {
                this._srcObject = stream;
                this.src = URL.createObjectURL(stream);
            }
        }});
    }
    getUserMedia = window.navigator && window.navigator.getUserMedia;
}
attachMediaStream = function(element, stream) {
    element.srcObject = stream;
};
reattachMediaStream = function(to, from) {
    to.srcObject = from.srcObject;
};
if (typeof window === "undefined" || !window.navigator) {
    webrtcUtils.log("This does not appear to be a browser");
    webrtcDetectedBrowser = "not a browser";
} else {
    if (navigator.mozGetUserMedia && window.mozRTCPeerConnection) {
        webrtcUtils.log("This appears to be Firefox");
        webrtcDetectedBrowser = "firefox";
        webrtcDetectedVersion = webrtcUtils.extractVersion(navigator.userAgent, /Firefox\/([0-9]+)\./, 1);
        webrtcMinimumVersion = 31;
        window.RTCPeerConnection = function(pcConfig, pcConstraints) {
            if (webrtcDetectedVersion < 38) {
                if (pcConfig && pcConfig.iceServers) {
                    var newIceServers = [];
                    for (var i = 0;i < pcConfig.iceServers.length;i++) {
                        var server = pcConfig.iceServers[i];
                        if (server.hasOwnProperty("urls")) {
                            for (var j = 0;j < server.urls.length;j++) {
                                var newServer = {url:server.urls[j]};
                                if (server.urls[j].indexOf("turn") === 0) {
                                    newServer.username = server.username;
                                    newServer.credential = server.credential;
                                }
                                newIceServers.push(newServer);
                            }
                        } else {
                            newIceServers.push(pcConfig.iceServers[i]);
                        }
                    }
                    pcConfig.iceServers = newIceServers;
                }
            }
            return new mozRTCPeerConnection(pcConfig, pcConstraints);
        };
        if (mozRTCPeerConnection.generateCertificate) {
            Object.defineProperty(window.RTCPeerConnection, "generateCertificate", {get:function() {
                if (arguments.length) {
                    return mozRTCPeerConnection.generateCertificate.apply(null, arguments);
                } else {
                    return mozRTCPeerConnection.generateCertificate;
                }
            }});
        }
        if (!window.RTCSessionDescription) {
            window.RTCSessionDescription = mozRTCSessionDescription;
        }
        if (!window.RTCIceCandidate) {
            window.RTCIceCandidate = mozRTCIceCandidate;
        }
        getUserMedia = function(constraints, onSuccess, onError) {
            var constraintsToFF37 = function(c) {
                if (typeof c !== "object" || c.require) {
                    return c;
                }
                var require = [];
                Object.keys(c).forEach(function(key) {
                    if (key === "require" || key === "advanced" || key === "mediaSource") {
                        return;
                    }
                    var r = c[key] = typeof c[key] === "object" ? c[key] : {ideal:c[key]};
                    if (r.min !== undefined || r.max !== undefined || r.exact !== undefined) {
                        require.push(key);
                    }
                    if (r.exact !== undefined) {
                        if (typeof r.exact === "number") {
                            r.min = r.max = r.exact;
                        } else {
                            c[key] = r.exact;
                        }
                        delete r.exact;
                    }
                    if (r.ideal !== undefined) {
                        c.advanced = c.advanced || [];
                        var oc = {};
                        if (typeof r.ideal === "number") {
                            oc[key] = {min:r.ideal, max:r.ideal};
                        } else {
                            oc[key] = r.ideal;
                        }
                        c.advanced.push(oc);
                        delete r.ideal;
                        if (!Object.keys(r).length) {
                            delete c[key];
                        }
                    }
                });
                if (require.length) {
                    c.require = require;
                }
                return c;
            };
            if (webrtcDetectedVersion < 38) {
                webrtcUtils.log("spec: " + JSON.stringify(constraints));
                if (constraints.audio) {
                    constraints.audio = constraintsToFF37(constraints.audio);
                }
                if (constraints.video) {
                    constraints.video = constraintsToFF37(constraints.video);
                }
                webrtcUtils.log("ff37: " + JSON.stringify(constraints));
            }
            return navigator.mozGetUserMedia(constraints, onSuccess, onError);
        };
        navigator.getUserMedia = getUserMedia;
        if (!navigator.mediaDevices) {
            navigator.mediaDevices = {getUserMedia:requestUserMedia, addEventListener:function() {
            }, removeEventListener:function() {
            }};
        }
        navigator.mediaDevices.enumerateDevices = navigator.mediaDevices.enumerateDevices || function() {
                return new Promise(function(resolve) {
                    var infos = [{kind:"audioinput", deviceId:"default", label:"", groupId:""}, {kind:"videoinput", deviceId:"default", label:"", groupId:""}];
                    resolve(infos);
                });
            };
        if (webrtcDetectedVersion < 41) {
            var orgEnumerateDevices = navigator.mediaDevices.enumerateDevices.bind(navigator.mediaDevices);
            navigator.mediaDevices.enumerateDevices = function() {
                return orgEnumerateDevices().then(undefined, function(e) {
                    if (e.name === "NotFoundError") {
                        return [];
                    }
                    throw e;
                });
            };
        }
    } else {
        if (navigator.webkitGetUserMedia && window.webkitRTCPeerConnection) {
            webrtcUtils.log("This appears to be Chrome");
            webrtcDetectedBrowser = "chrome";
            webrtcDetectedVersion = webrtcUtils.extractVersion(navigator.userAgent, /Chrom(e|ium)\/([0-9]+)\./, 2);
            webrtcMinimumVersion = 38;
            window.RTCPeerConnection = function(pcConfig, pcConstraints) {
                if (pcConfig && pcConfig.iceTransportPolicy) {
                    pcConfig.iceTransports = pcConfig.iceTransportPolicy;
                }
                var pc = new webkitRTCPeerConnection(pcConfig, pcConstraints);
                var origGetStats = pc.getStats.bind(pc);
                pc.getStats = function(selector, successCallback, errorCallback) {
                    var self = this;
                    var args = arguments;
                    if (arguments.length > 0 && typeof selector === "function") {
                        return origGetStats(selector, successCallback);
                    }
                    var fixChromeStats = function(response) {
                        var standardReport = {};
                        var reports = response.result();
                        reports.forEach(function(report) {
                            var standardStats = {id:report.id, timestamp:report.timestamp, type:report.type};
                            report.names().forEach(function(name) {
                                standardStats[name] = report.stat(name);
                            });
                            standardReport[standardStats.id] = standardStats;
                        });
                        return standardReport;
                    };
                    if (arguments.length >= 2) {
                        var successCallbackWrapper = function(response) {
                            args[1](fixChromeStats(response));
                        };
                        return origGetStats.apply(this, [successCallbackWrapper, arguments[0]]);
                    }
                    return new Promise(function(resolve, reject) {
                        if (args.length === 1 && selector === null) {
                            origGetStats.apply(self, [function(response) {
                                resolve.apply(null, [fixChromeStats(response)]);
                            }, reject]);
                        } else {
                            origGetStats.apply(self, [resolve, reject]);
                        }
                    });
                };
                return pc;
            };
            if (webkitRTCPeerConnection.generateCertificate) {
                Object.defineProperty(window.RTCPeerConnection, "generateCertificate", {get:function() {
                    if (arguments.length) {
                        return webkitRTCPeerConnection.generateCertificate.apply(null, arguments);
                    } else {
                        return webkitRTCPeerConnection.generateCertificate;
                    }
                }});
            }
            ["createOffer", "createAnswer"].forEach(function(method) {
                var nativeMethod = webkitRTCPeerConnection.prototype[method];
                webkitRTCPeerConnection.prototype[method] = function() {
                    var self = this;
                    if (arguments.length < 1 || arguments.length === 1 && typeof arguments[0] === "object") {
                        var opts = arguments.length === 1 ? arguments[0] : undefined;
                        return new Promise(function(resolve, reject) {
                            nativeMethod.apply(self, [resolve, reject, opts]);
                        });
                    } else {
                        return nativeMethod.apply(this, arguments);
                    }
                };
            });
            ["setLocalDescription", "setRemoteDescription", "addIceCandidate"].forEach(function(method) {
                var nativeMethod = webkitRTCPeerConnection.prototype[method];
                webkitRTCPeerConnection.prototype[method] = function() {
                    var args = arguments;
                    var self = this;
                    return new Promise(function(resolve, reject) {
                        nativeMethod.apply(self, [args[0], function() {
                            resolve();
                            if (args.length >= 2) {
                                args[1].apply(null, []);
                            }
                        }, function(err) {
                            reject(err);
                            if (args.length >= 3) {
                                args[2].apply(null, [err]);
                            }
                        }]);
                    });
                };
            });
            var constraintsToChrome = function(c) {
                if (typeof c !== "object" || c.mandatory || c.optional) {
                    return c;
                }
                var cc = {};
                Object.keys(c).forEach(function(key) {
                    if (key === "require" || key === "advanced" || key === "mediaSource") {
                        return;
                    }
                    var r = typeof c[key] === "object" ? c[key] : {ideal:c[key]};
                    if (r.exact !== undefined && typeof r.exact === "number") {
                        r.min = r.max = r.exact;
                    }
                    var oldname = function(prefix, name) {
                        if (prefix) {
                            return prefix + name.charAt(0).toUpperCase() + name.slice(1);
                        }
                        return name === "deviceId" ? "sourceId" : name;
                    };
                    if (r.ideal !== undefined) {
                        cc.optional = cc.optional || [];
                        var oc = {};
                        if (typeof r.ideal === "number") {
                            oc[oldname("min", key)] = r.ideal;
                            cc.optional.push(oc);
                            oc = {};
                            oc[oldname("max", key)] = r.ideal;
                            cc.optional.push(oc);
                        } else {
                            oc[oldname("", key)] = r.ideal;
                            cc.optional.push(oc);
                        }
                    }
                    if (r.exact !== undefined && typeof r.exact !== "number") {
                        cc.mandatory = cc.mandatory || {};
                        cc.mandatory[oldname("", key)] = r.exact;
                    } else {
                        ["min", "max"].forEach(function(mix) {
                            if (r[mix] !== undefined) {
                                cc.mandatory = cc.mandatory || {};
                                cc.mandatory[oldname(mix, key)] = r[mix];
                            }
                        });
                    }
                });
                if (c.advanced) {
                    cc.optional = (cc.optional || []).concat(c.advanced);
                }
                return cc;
            };
            getUserMedia = function(constraints, onSuccess, onError) {
                if (constraints.audio) {
                    constraints.audio = constraintsToChrome(constraints.audio);
                }
                if (constraints.video) {
                    constraints.video = constraintsToChrome(constraints.video);
                }
                webrtcUtils.log("chrome: " + JSON.stringify(constraints));
                return navigator.webkitGetUserMedia(constraints, onSuccess, onError);
            };
            navigator.getUserMedia = getUserMedia;
            if (!navigator.mediaDevices) {
                navigator.mediaDevices = {getUserMedia:requestUserMedia, enumerateDevices:function() {
                    return new Promise(function(resolve) {
                        var kinds = {audio:"audioinput", video:"videoinput"};
                        return MediaStreamTrack.getSources(function(devices) {
                            resolve(devices.map(function(device) {
                                return {label:device.label, kind:kinds[device.kind], deviceId:device.id, groupId:""};
                            }));
                        });
                    });
                }};
            }
            if (!navigator.mediaDevices.getUserMedia) {
                navigator.mediaDevices.getUserMedia = function(constraints) {
                    return requestUserMedia(constraints);
                };
            } else {
                var origGetUserMedia = navigator.mediaDevices.getUserMedia.bind(navigator.mediaDevices);
                navigator.mediaDevices.getUserMedia = function(c) {
                    webrtcUtils.log("spec:   " + JSON.stringify(c));
                    c.audio = constraintsToChrome(c.audio);
                    c.video = constraintsToChrome(c.video);
                    webrtcUtils.log("chrome: " + JSON.stringify(c));
                    return origGetUserMedia(c);
                };
            }
            if (typeof navigator.mediaDevices.addEventListener === "undefined") {
                navigator.mediaDevices.addEventListener = function() {
                    webrtcUtils.log("Dummy mediaDevices.addEventListener called.");
                };
            }
            if (typeof navigator.mediaDevices.removeEventListener === "undefined") {
                navigator.mediaDevices.removeEventListener = function() {
                    webrtcUtils.log("Dummy mediaDevices.removeEventListener called.");
                };
            }
            attachMediaStream = function(element, stream) {
                if (webrtcDetectedVersion >= 43) {
                    element.srcObject = stream;
                } else {
                    if (typeof element.src !== "undefined") {
                        element.src = URL.createObjectURL(stream);
                    } else {
                        webrtcUtils.log("Error attaching stream to element.");
                    }
                }
            };
            reattachMediaStream = function(to, from) {
                if (webrtcDetectedVersion >= 43) {
                    to.srcObject = from.srcObject;
                } else {
                    to.src = from.src;
                }
            };
        } else {
            if (navigator.mediaDevices && navigator.userAgent.match(/Edge\/(\d+).(\d+)$/)) {
                webrtcUtils.log("This appears to be Edge");
                webrtcDetectedBrowser = "edge";
                webrtcDetectedVersion = webrtcUtils.extractVersion(navigator.userAgent, /Edge\/(\d+).(\d+)$/, 2);
                webrtcMinimumVersion = 10547;
                if (RTCIceGatherer) {
                    var generateIdentifier = function() {
                        return Math.random().toString(36).substr(2, 10);
                    };
                    var localCName = generateIdentifier();
                    var SDPUtils = {};
                    SDPUtils.splitLines = function(blob) {
                        return blob.trim().split("\n").map(function(line) {
                            return line.trim();
                        });
                    };
                    SDPUtils.splitSections = function(blob) {
                        var parts = blob.split("\r\nm=");
                        return parts.map(function(part, index) {
                            return (index > 0 ? "m=" + part : part).trim() + "\r\n";
                        });
                    };
                    SDPUtils.matchPrefix = function(blob, prefix) {
                        return SDPUtils.splitLines(blob).filter(function(line) {
                            return line.indexOf(prefix) === 0;
                        });
                    };
                    SDPUtils.parseCandidate = function(line) {
                        var parts;
                        if (line.indexOf("a=candidate:") === 0) {
                            parts = line.substring(12).split(" ");
                        } else {
                            parts = line.substring(10).split(" ");
                        }
                        var candidate = {foundation:parts[0], component:parts[1], protocol:parts[2].toLowerCase(), priority:parseInt(parts[3], 10), ip:parts[4], port:parseInt(parts[5], 10), type:parts[7]};
                        for (var i = 8;i < parts.length;i += 2) {
                            switch(parts[i]) {
                                case "raddr":
                                    candidate.relatedAddress = parts[i + 1];
                                    break;
                                case "rport":
                                    candidate.relatedPort = parseInt(parts[i + 1], 10);
                                    break;
                                case "tcptype":
                                    candidate.tcpType = parts[i + 1];
                                    break;
                                default:
                                    break;
                            }
                        }
                        return candidate;
                    };
                    SDPUtils.writeCandidate = function(candidate) {
                        var sdp = [];
                        sdp.push(candidate.foundation);
                        sdp.push(candidate.component);
                        sdp.push(candidate.protocol.toUpperCase());
                        sdp.push(candidate.priority);
                        sdp.push(candidate.ip);
                        sdp.push(candidate.port);
                        var type = candidate.type;
                        sdp.push("typ");
                        sdp.push(type);
                        if (type !== "host" && candidate.relatedAddress && candidate.relatedPort) {
                            sdp.push("raddr");
                            sdp.push(candidate.relatedAddress);
                            sdp.push("rport");
                            sdp.push(candidate.relatedPort);
                        }
                        if (candidate.tcpType && candidate.protocol.toLowerCase() === "tcp") {
                            sdp.push("tcptype");
                            sdp.push(candidate.tcpType);
                        }
                        return "candidate:" + sdp.join(" ");
                    };
                    SDPUtils.parseRtpMap = function(line) {
                        var parts = line.substr(9).split(" ");
                        var parsed = {payloadType:parseInt(parts.shift(), 10)};
                        parts = parts[0].split("/");
                        parsed.name = parts[0];
                        parsed.clockRate = parseInt(parts[1], 10);
                        parsed.numChannels = parts.length === 3 ? parseInt(parts[2], 10) : 1;
                        return parsed;
                    };
                    SDPUtils.writeRtpMap = function(codec) {
                        var pt = codec.payloadType;
                        if (codec.preferredPayloadType !== undefined) {
                            pt = codec.preferredPayloadType;
                        }
                        return "a=rtpmap:" + pt + " " + codec.name + "/" + codec.clockRate + (codec.numChannels !== 1 ? "/" + codec.numChannels : "") + "\r\n";
                    };
                    SDPUtils.parseFmtp = function(line) {
                        var parsed = {};
                        var kv;
                        var parts = line.substr(line.indexOf(" ") + 1).split(";");
                        for (var j = 0;j < parts.length;j++) {
                            kv = parts[j].trim().split("=");
                            parsed[kv[0].trim()] = kv[1];
                        }
                        return parsed;
                    };
                    SDPUtils.writeFtmp = function(codec) {
                        var line = "";
                        var pt = codec.payloadType;
                        if (codec.preferredPayloadType !== undefined) {
                            pt = codec.preferredPayloadType;
                        }
                        if (codec.parameters && codec.parameters.length) {
                            var params = [];
                            Object.keys(codec.parameters).forEach(function(param) {
                                params.push(param + "=" + codec.parameters[param]);
                            });
                            line += "a=fmtp:" + pt + " " + params.join(";") + "\r\n";
                        }
                        return line;
                    };
                    SDPUtils.parseRtcpFb = function(line) {
                        var parts = line.substr(line.indexOf(" ") + 1).split(" ");
                        return {type:parts.shift(), parameter:parts.join(" ")};
                    };
                    SDPUtils.writeRtcpFb = function(codec) {
                        var lines = "";
                        var pt = codec.payloadType;
                        if (codec.preferredPayloadType !== undefined) {
                            pt = codec.preferredPayloadType;
                        }
                        if (codec.rtcpFeedback && codec.rtcpFeedback.length) {
                            codec.rtcpFeedback.forEach(function(fb) {
                                lines += "a=rtcp-fb:" + pt + " " + fb.type + " " + fb.parameter + "\r\n";
                            });
                        }
                        return lines;
                    };
                    SDPUtils.parseSsrcMedia = function(line) {
                        var sp = line.indexOf(" ");
                        var parts = {ssrc:line.substr(7, sp - 7)};
                        var colon = line.indexOf(":", sp);
                        if (colon > -1) {
                            parts.attribute = line.substr(sp + 1, colon - sp - 1);
                            parts.value = line.substr(colon + 1);
                        } else {
                            parts.attribute = line.substr(sp + 1);
                        }
                        return parts;
                    };
                    SDPUtils.getDtlsParameters = function(mediaSection, sessionpart) {
                        var lines = SDPUtils.splitLines(mediaSection);
                        lines = lines.concat(SDPUtils.splitLines(sessionpart));
                        var fpLine = lines.filter(function(line) {
                            return line.indexOf("a=fingerprint:") === 0;
                        })[0].substr(14);
                        var dtlsParameters = {role:"auto", fingerprints:[{algorithm:fpLine.split(" ")[0], value:fpLine.split(" ")[1]}]};
                        return dtlsParameters;
                    };
                    SDPUtils.writeDtlsParameters = function(params, setupType) {
                        var sdp = "a=setup:" + setupType + "\r\n";
                        params.fingerprints.forEach(function(fp) {
                            sdp += "a=fingerprint:" + fp.algorithm + " " + fp.value + "\r\n";
                        });
                        return sdp;
                    };
                    SDPUtils.getIceParameters = function(mediaSection, sessionpart) {
                        var lines = SDPUtils.splitLines(mediaSection);
                        lines = lines.concat(SDPUtils.splitLines(sessionpart));
                        var iceParameters = {usernameFragment:lines.filter(function(line) {
                            return line.indexOf("a=ice-ufrag:") === 0;
                        })[0].substr(12), password:lines.filter(function(line) {
                            return line.indexOf("a=ice-pwd:") === 0;
                        })[0].substr(10)};
                        return iceParameters;
                    };
                    SDPUtils.writeIceParameters = function(params) {
                        return "a=ice-ufrag:" + params.usernameFragment + "\r\n" + "a=ice-pwd:" + params.password + "\r\n";
                    };
                    SDPUtils.parseRtpParameters = function(mediaSection) {
                        var description = {codecs:[], headerExtensions:[], fecMechanisms:[], rtcp:[]};
                        var lines = SDPUtils.splitLines(mediaSection);
                        var mline = lines[0].split(" ");
                        for (var i = 3;i < mline.length;i++) {
                            var pt = mline[i];
                            var rtpmapline = SDPUtils.matchPrefix(mediaSection, "a=rtpmap:" + pt + " ")[0];
                            if (rtpmapline) {
                                var codec = SDPUtils.parseRtpMap(rtpmapline);
                                var fmtps = SDPUtils.matchPrefix(mediaSection, "a=fmtp:" + pt + " ");
                                codec.parameters = fmtps.length ? SDPUtils.parseFmtp(fmtps[0]) : {};
                                codec.rtcpFeedback = SDPUtils.matchPrefix(mediaSection, "a=rtcp-fb:" + pt + " ").map(SDPUtils.parseRtcpFb);
                                description.codecs.push(codec);
                            }
                        }
                        return description;
                    };
                    SDPUtils.writeRtpDescription = function(kind, caps) {
                        var sdp = "";
                        sdp += "m=" + kind + " ";
                        sdp += caps.codecs.length > 0 ? "9" : "0";
                        sdp += " UDP/TLS/RTP/SAVPF ";
                        sdp += caps.codecs.map(function(codec) {
                                if (codec.preferredPayloadType !== undefined) {
                                    return codec.preferredPayloadType;
                                }
                                return codec.payloadType;
                            }).join(" ") + "\r\n";
                        sdp += "c=IN IP4 0.0.0.0\r\n";
                        sdp += "a=rtcp:9 IN IP4 0.0.0.0\r\n";
                        caps.codecs.forEach(function(codec) {
                            sdp += SDPUtils.writeRtpMap(codec);
                            sdp += SDPUtils.writeFtmp(codec);
                            sdp += SDPUtils.writeRtcpFb(codec);
                        });
                        sdp += "a=rtcp-mux\r\n";
                        return sdp;
                    };
                    SDPUtils.writeSessionBoilerplate = function() {
                        return "v=0\r\n" + "o=thisisadapterortc 8169639915646943137 2 IN IP4 127.0.0.1\r\n" + "s=-\r\n" + "t=0 0\r\n";
                    };
                    SDPUtils.writeMediaSection = function(transceiver, caps, type, stream) {
                        var sdp = SDPUtils.writeRtpDescription(transceiver.kind, caps);
                        sdp += SDPUtils.writeIceParameters(transceiver.iceGatherer.getLocalParameters());
                        sdp += SDPUtils.writeDtlsParameters(transceiver.dtlsTransport.getLocalParameters(), type === "offer" ? "actpass" : "active");
                        sdp += "a=mid:" + transceiver.mid + "\r\n";
                        if (transceiver.rtpSender && transceiver.rtpReceiver) {
                            sdp += "a=sendrecv\r\n";
                        } else {
                            if (transceiver.rtpSender) {
                                sdp += "a=sendonly\r\n";
                            } else {
                                if (transceiver.rtpReceiver) {
                                    sdp += "a=recvonly\r\n";
                                } else {
                                    sdp += "a=inactive\r\n";
                                }
                            }
                        }
                        if (transceiver.rtpSender) {
                            var msid = "msid:" + stream.id + " " + transceiver.rtpSender.track.id + "\r\n";
                            sdp += "a=" + msid;
                            sdp += "a=ssrc:" + transceiver.sendSsrc + " " + msid;
                        }
                        sdp += "a=ssrc:" + transceiver.sendSsrc + " cname:" + localCName + "\r\n";
                        return sdp;
                    };
                    SDPUtils.getDirection = function(mediaSection, sessionpart) {
                        var lines = SDPUtils.splitLines(mediaSection);
                        for (var i = 0;i < lines.length;i++) {
                            switch(lines[i]) {
                                case "a=sendrecv":
                                    ;
                                case "a=sendonly":
                                    ;
                                case "a=recvonly":
                                    ;
                                case "a=inactive":
                                    return lines[i].substr(2);
                            }
                        }
                        if (sessionpart) {
                            return SDPUtils.getDirection(sessionpart);
                        }
                        return "sendrecv";
                    };
                    if (!window.RTCIceCandidate) {
                        window.RTCIceCandidate = function(args) {
                            return args;
                        };
                    }
                    if (!window.RTCSessionDescription) {
                        window.RTCSessionDescription = function(args) {
                            return args;
                        };
                    }
                    window.RTCPeerConnection = function(config) {
                        var self = this;
                        this.onicecandidate = null;
                        this.onaddstream = null;
                        this.onremovestream = null;
                        this.onsignalingstatechange = null;
                        this.oniceconnectionstatechange = null;
                        this.onnegotiationneeded = null;
                        this.ondatachannel = null;
                        this.localStreams = [];
                        this.remoteStreams = [];
                        this.getLocalStreams = function() {
                            return self.localStreams;
                        };
                        this.getRemoteStreams = function() {
                            return self.remoteStreams;
                        };
                        this.localDescription = new RTCSessionDescription({type:"", sdp:""});
                        this.remoteDescription = new RTCSessionDescription({type:"", sdp:""});
                        this.signalingState = "stable";
                        this.iceConnectionState = "new";
                        this.iceOptions = {gatherPolicy:"all", iceServers:[]};
                        if (config && config.iceTransportPolicy) {
                            switch(config.iceTransportPolicy) {
                                case "all":
                                    ;
                                case "relay":
                                    this.iceOptions.gatherPolicy = config.iceTransportPolicy;
                                    break;
                                case "none":
                                    throw new TypeError('iceTransportPolicy "none" not supported');;
                            }
                        }
                        if (config && config.iceServers) {
                            config.iceServers.forEach(function(server) {
                                if (server.urls) {
                                    var url;
                                    if (typeof server.urls === "string") {
                                        url = server.urls;
                                    } else {
                                        url = server.urls[0];
                                    }
                                    if (url.indexOf("transport=udp") !== -1) {
                                        self.iceServers.push({username:server.username, credential:server.credential, urls:url});
                                    }
                                }
                            });
                        }
                        this.transceivers = [];
                        this._localIceCandidatesBuffer = [];
                    };
                    window.RTCPeerConnection.prototype._emitBufferedCandidates = function() {
                        var self = this;
                        this._localIceCandidatesBuffer.forEach(function(event) {
                            if (self.onicecandidate !== null) {
                                self.onicecandidate(event);
                            }
                        });
                        this._localIceCandidatesBuffer = [];
                    };
                    window.RTCPeerConnection.prototype.addStream = function(stream) {
                        this.localStreams.push(stream.clone());
                        this._maybeFireNegotiationNeeded();
                    };
                    window.RTCPeerConnection.prototype.removeStream = function(stream) {
                        var idx = this.localStreams.indexOf(stream);
                        if (idx > -1) {
                            this.localStreams.splice(idx, 1);
                            this._maybeFireNegotiationNeeded();
                        }
                    };
                    window.RTCPeerConnection.prototype._getCommonCapabilities = function(localCapabilities, remoteCapabilities) {
                        var commonCapabilities = {codecs:[], headerExtensions:[], fecMechanisms:[]};
                        localCapabilities.codecs.forEach(function(lCodec) {
                            for (var i = 0;i < remoteCapabilities.codecs.length;i++) {
                                var rCodec = remoteCapabilities.codecs[i];
                                if (lCodec.name.toLowerCase() === rCodec.name.toLowerCase() && lCodec.clockRate === rCodec.clockRate && lCodec.numChannels === rCodec.numChannels) {
                                    commonCapabilities.codecs.push(rCodec);
                                    break;
                                }
                            }
                        });
                        localCapabilities.headerExtensions.forEach(function(lHeaderExtension) {
                            for (var i = 0;i < remoteCapabilities.headerExtensions.length;i++) {
                                var rHeaderExtension = remoteCapabilities.headerExtensions[i];
                                if (lHeaderExtension.uri === rHeaderExtension.uri) {
                                    commonCapabilities.headerExtensions.push(rHeaderExtension);
                                    break;
                                }
                            }
                        });
                        return commonCapabilities;
                    };
                    window.RTCPeerConnection.prototype._createIceAndDtlsTransports = function(mid, sdpMLineIndex) {
                        var self = this;
                        var iceGatherer = new RTCIceGatherer(self.iceOptions);
                        var iceTransport = new RTCIceTransport(iceGatherer);
                        iceGatherer.onlocalcandidate = function(evt) {
                            var event = {};
                            event.candidate = {sdpMid:mid, sdpMLineIndex:sdpMLineIndex};
                            var cand = evt.candidate;
                            if (!cand || Object.keys(cand).length === 0) {
                                if (iceGatherer.state === undefined) {
                                    iceGatherer.state = "completed";
                                }
                                event.candidate.candidate = "candidate:1 1 udp 1 0.0.0.0 9 typ endOfCandidates";
                            } else {
                                cand.component = iceTransport.component === "RTCP" ? 2 : 1;
                                event.candidate.candidate = SDPUtils.writeCandidate(cand);
                            }
                            var complete = self.transceivers.every(function(transceiver) {
                                return transceiver.iceGatherer && transceiver.iceGatherer.state === "completed";
                            });
                            if (self.onicecandidate !== null) {
                                if (self.localDescription && self.localDescription.type === "") {
                                    self._localIceCandidatesBuffer.push(event);
                                    if (complete) {
                                        self._localIceCandidatesBuffer.push({});
                                    }
                                } else {
                                    self.onicecandidate(event);
                                    if (complete) {
                                        self.onicecandidate({});
                                    }
                                }
                            }
                        };
                        iceTransport.onicestatechange = function() {
                            self._updateConnectionState();
                        };
                        var dtlsTransport = new RTCDtlsTransport(iceTransport);
                        dtlsTransport.ondtlsstatechange = function() {
                            self._updateConnectionState();
                        };
                        dtlsTransport.onerror = function() {
                            dtlsTransport.state = "failed";
                            self._updateConnectionState();
                        };
                        return {iceGatherer:iceGatherer, iceTransport:iceTransport, dtlsTransport:dtlsTransport};
                    };
                    window.RTCPeerConnection.prototype._transceive = function(transceiver, send, recv) {
                        var params = this._getCommonCapabilities(transceiver.localCapabilities, transceiver.remoteCapabilities);
                        if (send && transceiver.rtpSender) {
                            params.encodings = [{ssrc:transceiver.sendSsrc}];
                            params.rtcp = {cname:localCName, ssrc:transceiver.recvSsrc};
                            transceiver.rtpSender.send(params);
                        }
                        if (recv && transceiver.rtpReceiver) {
                            params.encodings = [{ssrc:transceiver.recvSsrc}];
                            params.rtcp = {cname:transceiver.cname, ssrc:transceiver.sendSsrc};
                            transceiver.rtpReceiver.receive(params);
                        }
                    };
                    window.RTCPeerConnection.prototype.setLocalDescription = function(description) {
                        var self = this;
                        if (description.type === "offer") {
                            if (!this._pendingOffer) {
                            } else {
                                this.transceivers = this._pendingOffer;
                                delete this._pendingOffer;
                            }
                        } else {
                            if (description.type === "answer") {
                                var sections = SDPUtils.splitSections(self.remoteDescription.sdp);
                                var sessionpart = sections.shift();
                                sections.forEach(function(mediaSection, sdpMLineIndex) {
                                    var transceiver = self.transceivers[sdpMLineIndex];
                                    var iceGatherer = transceiver.iceGatherer;
                                    var iceTransport = transceiver.iceTransport;
                                    var dtlsTransport = transceiver.dtlsTransport;
                                    var localCapabilities = transceiver.localCapabilities;
                                    var remoteCapabilities = transceiver.remoteCapabilities;
                                    var rejected = mediaSection.split("\n", 1)[0].split(" ", 2)[1] === "0";
                                    if (!rejected) {
                                        var remoteIceParameters = SDPUtils.getIceParameters(mediaSection, sessionpart);
                                        iceTransport.start(iceGatherer, remoteIceParameters, "controlled");
                                        var remoteDtlsParameters = SDPUtils.getDtlsParameters(mediaSection, sessionpart);
                                        dtlsTransport.start(remoteDtlsParameters);
                                        var params = self._getCommonCapabilities(localCapabilities, remoteCapabilities);
                                        self._transceive(transceiver, params.codecs.length > 0, false);
                                    }
                                });
                            }
                        }
                        this.localDescription = description;
                        switch(description.type) {
                            case "offer":
                                this._updateSignalingState("have-local-offer");
                                break;
                            case "answer":
                                this._updateSignalingState("stable");
                                break;
                            default:
                                throw new TypeError('unsupported type "' + description.type + '"');;
                        }
                        var hasCallback = arguments.length > 1 && typeof arguments[1] === "function";
                        if (hasCallback) {
                            var cb = arguments[1];
                            window.setTimeout(function() {
                                cb();
                                self._emitBufferedCandidates();
                            }, 0);
                        }
                        var p = Promise.resolve();
                        p.then(function() {
                            if (!hasCallback) {
                                window.setTimeout(self._emitBufferedCandidates.bind(self), 0);
                            }
                        });
                        return p;
                    };
                    window.RTCPeerConnection.prototype.setRemoteDescription = function(description) {
                        var self = this;
                        var stream = new MediaStream;
                        var sections = SDPUtils.splitSections(description.sdp);
                        var sessionpart = sections.shift();
                        sections.forEach(function(mediaSection, sdpMLineIndex) {
                            var lines = SDPUtils.splitLines(mediaSection);
                            var mline = lines[0].substr(2).split(" ");
                            var kind = mline[0];
                            var rejected = mline[1] === "0";
                            var direction = SDPUtils.getDirection(mediaSection, sessionpart);
                            var transceiver;
                            var iceGatherer;
                            var iceTransport;
                            var dtlsTransport;
                            var rtpSender;
                            var rtpReceiver;
                            var sendSsrc;
                            var recvSsrc;
                            var localCapabilities;
                            var remoteCapabilities = SDPUtils.parseRtpParameters(mediaSection);
                            var remoteIceParameters;
                            var remoteDtlsParameters;
                            if (!rejected) {
                                remoteIceParameters = SDPUtils.getIceParameters(mediaSection, sessionpart);
                                remoteDtlsParameters = SDPUtils.getDtlsParameters(mediaSection, sessionpart);
                            }
                            var mid = SDPUtils.matchPrefix(mediaSection, "a=mid:")[0].substr(6);
                            var cname;
                            var remoteSsrc = SDPUtils.matchPrefix(mediaSection, "a=ssrc:").map(function(line) {
                                return SDPUtils.parseSsrcMedia(line);
                            }).filter(function(obj) {
                                return obj.attribute === "cname";
                            })[0];
                            if (remoteSsrc) {
                                recvSsrc = parseInt(remoteSsrc.ssrc, 10);
                                cname = remoteSsrc.value;
                            }
                            if (description.type === "offer") {
                                var transports = self._createIceAndDtlsTransports(mid, sdpMLineIndex);
                                localCapabilities = RTCRtpReceiver.getCapabilities(kind);
                                sendSsrc = (2 * sdpMLineIndex + 2) * 1001;
                                rtpReceiver = new RTCRtpReceiver(transports.dtlsTransport, kind);
                                stream.addTrack(rtpReceiver.track);
                                if (self.localStreams.length > 0 && self.localStreams[0].getTracks().length >= sdpMLineIndex) {
                                    var localtrack = self.localStreams[0].getTracks()[sdpMLineIndex];
                                    rtpSender = new RTCRtpSender(localtrack, transports.dtlsTransport);
                                }
                                self.transceivers[sdpMLineIndex] = {iceGatherer:transports.iceGatherer, iceTransport:transports.iceTransport, dtlsTransport:transports.dtlsTransport, localCapabilities:localCapabilities, remoteCapabilities:remoteCapabilities, rtpSender:rtpSender, rtpReceiver:rtpReceiver, kind:kind, mid:mid, cname:cname, sendSsrc:sendSsrc, recvSsrc:recvSsrc};
                                self._transceive(self.transceivers[sdpMLineIndex], false, direction === "sendrecv" || direction === "sendonly");
                            } else {
                                if (description.type === "answer" && !rejected) {
                                    transceiver = self.transceivers[sdpMLineIndex];
                                    iceGatherer = transceiver.iceGatherer;
                                    iceTransport = transceiver.iceTransport;
                                    dtlsTransport = transceiver.dtlsTransport;
                                    rtpSender = transceiver.rtpSender;
                                    rtpReceiver = transceiver.rtpReceiver;
                                    sendSsrc = transceiver.sendSsrc;
                                    localCapabilities = transceiver.localCapabilities;
                                    self.transceivers[sdpMLineIndex].recvSsrc = recvSsrc;
                                    self.transceivers[sdpMLineIndex].remoteCapabilities = remoteCapabilities;
                                    self.transceivers[sdpMLineIndex].cname = cname;
                                    iceTransport.start(iceGatherer, remoteIceParameters, "controlling");
                                    dtlsTransport.start(remoteDtlsParameters);
                                    self._transceive(transceiver, direction === "sendrecv" || direction === "recvonly", direction === "sendrecv" || direction === "sendonly");
                                    if (rtpReceiver && (direction === "sendrecv" || direction === "sendonly")) {
                                        stream.addTrack(rtpReceiver.track);
                                    } else {
                                        delete transceiver.rtpReceiver;
                                    }
                                }
                            }
                        });
                        this.remoteDescription = description;
                        switch(description.type) {
                            case "offer":
                                this._updateSignalingState("have-remote-offer");
                                break;
                            case "answer":
                                this._updateSignalingState("stable");
                                break;
                            default:
                                throw new TypeError('unsupported type "' + description.type + '"');;
                        }
                        window.setTimeout(function() {
                            if (self.onaddstream !== null && stream.getTracks().length) {
                                self.remoteStreams.push(stream);
                                window.setTimeout(function() {
                                    self.onaddstream({stream:stream});
                                }, 0);
                            }
                        }, 0);
                        if (arguments.length > 1 && typeof arguments[1] === "function") {
                            window.setTimeout(arguments[1], 0);
                        }
                        return Promise.resolve();
                    };
                    window.RTCPeerConnection.prototype.close = function() {
                        this.transceivers.forEach(function(transceiver) {
                            if (transceiver.iceTransport) {
                                transceiver.iceTransport.stop();
                            }
                            if (transceiver.dtlsTransport) {
                                transceiver.dtlsTransport.stop();
                            }
                            if (transceiver.rtpSender) {
                                transceiver.rtpSender.stop();
                            }
                            if (transceiver.rtpReceiver) {
                                transceiver.rtpReceiver.stop();
                            }
                        });
                        this._updateSignalingState("closed");
                    };
                    window.RTCPeerConnection.prototype._updateSignalingState = function(newState) {
                        this.signalingState = newState;
                        if (this.onsignalingstatechange !== null) {
                            this.onsignalingstatechange();
                        }
                    };
                    window.RTCPeerConnection.prototype._maybeFireNegotiationNeeded = function() {
                        if (this.onnegotiationneeded !== null) {
                            this.onnegotiationneeded();
                        }
                    };
                    window.RTCPeerConnection.prototype._updateConnectionState = function() {
                        var self = this;
                        var newState;
                        var states = {"new":0, closed:0, connecting:0, checking:0, connected:0, completed:0, failed:0};
                        this.transceivers.forEach(function(transceiver) {
                            states[transceiver.iceTransport.state]++;
                            states[transceiver.dtlsTransport.state]++;
                        });
                        states.connected += states.completed;
                        newState = "new";
                        if (states.failed > 0) {
                            newState = "failed";
                        } else {
                            if (states.connecting > 0 || states.checking > 0) {
                                newState = "connecting";
                            } else {
                                if (states.disconnected > 0) {
                                    newState = "disconnected";
                                } else {
                                    if (states["new"] > 0) {
                                        newState = "new";
                                    } else {
                                        if (states.connecting > 0 || states.completed > 0) {
                                            newState = "connected";
                                        }
                                    }
                                }
                            }
                        }
                        if (newState !== self.iceConnectionState) {
                            self.iceConnectionState = newState;
                            if (this.oniceconnectionstatechange !== null) {
                                this.oniceconnectionstatechange();
                            }
                        }
                    };
                    window.RTCPeerConnection.prototype.createOffer = function() {
                        var self = this;
                        if (this._pendingOffer) {
                            throw new Error("createOffer called while there is a pending offer.");
                        }
                        var offerOptions;
                        if (arguments.length === 1 && typeof arguments[0] !== "function") {
                            offerOptions = arguments[0];
                        } else {
                            if (arguments.length === 3) {
                                offerOptions = arguments[2];
                            }
                        }
                        var tracks = [];
                        var numAudioTracks = 0;
                        var numVideoTracks = 0;
                        if (this.localStreams.length) {
                            numAudioTracks = this.localStreams[0].getAudioTracks().length;
                            numVideoTracks = this.localStreams[0].getVideoTracks().length;
                        }
                        if (offerOptions) {
                            if (offerOptions.mandatory || offerOptions.optional) {
                                throw new TypeError("Legacy mandatory/optional constraints not supported.");
                            }
                            if (offerOptions.offerToReceiveAudio !== undefined) {
                                numAudioTracks = offerOptions.offerToReceiveAudio;
                            }
                            if (offerOptions.offerToReceiveVideo !== undefined) {
                                numVideoTracks = offerOptions.offerToReceiveVideo;
                            }
                        }
                        if (this.localStreams.length) {
                            this.localStreams[0].getTracks().forEach(function(track) {
                                tracks.push({kind:track.kind, track:track, wantReceive:track.kind === "audio" ? numAudioTracks > 0 : numVideoTracks > 0});
                                if (track.kind === "audio") {
                                    numAudioTracks--;
                                } else {
                                    if (track.kind === "video") {
                                        numVideoTracks--;
                                    }
                                }
                            });
                        }
                        while (numAudioTracks > 0 || numVideoTracks > 0) {
                            if (numAudioTracks > 0) {
                                tracks.push({kind:"audio", wantReceive:true});
                                numAudioTracks--;
                            }
                            if (numVideoTracks > 0) {
                                tracks.push({kind:"video", wantReceive:true});
                                numVideoTracks--;
                            }
                        }
                        var sdp = SDPUtils.writeSessionBoilerplate();
                        var transceivers = [];
                        tracks.forEach(function(mline, sdpMLineIndex) {
                            var track = mline.track;
                            var kind = mline.kind;
                            var mid = generateIdentifier();
                            var transports = self._createIceAndDtlsTransports(mid, sdpMLineIndex);
                            var localCapabilities = RTCRtpSender.getCapabilities(kind);
                            var rtpSender;
                            var rtpReceiver;
                            var sendSsrc = (2 * sdpMLineIndex + 1) * 1001;
                            if (track) {
                                rtpSender = new RTCRtpSender(track, transports.dtlsTransport);
                            }
                            if (mline.wantReceive) {
                                rtpReceiver = new RTCRtpReceiver(transports.dtlsTransport, kind);
                            }
                            transceivers[sdpMLineIndex] = {iceGatherer:transports.iceGatherer, iceTransport:transports.iceTransport, dtlsTransport:transports.dtlsTransport, localCapabilities:localCapabilities, remoteCapabilities:null, rtpSender:rtpSender, rtpReceiver:rtpReceiver, kind:kind, mid:mid, sendSsrc:sendSsrc, recvSsrc:null};
                            var transceiver = transceivers[sdpMLineIndex];
                            sdp += SDPUtils.writeMediaSection(transceiver, transceiver.localCapabilities, "offer", self.localStreams[0]);
                        });
                        this._pendingOffer = transceivers;
                        var desc = new RTCSessionDescription({type:"offer", sdp:sdp});
                        if (arguments.length && typeof arguments[0] === "function") {
                            window.setTimeout(arguments[0], 0, desc);
                        }
                        return Promise.resolve(desc);
                    };
                    window.RTCPeerConnection.prototype.createAnswer = function() {
                        var self = this;
                        var answerOptions;
                        if (arguments.length === 1 && typeof arguments[0] !== "function") {
                            answerOptions = arguments[0];
                        } else {
                            if (arguments.length === 3) {
                                answerOptions = arguments[2];
                            }
                        }
                        var sdp = SDPUtils.writeSessionBoilerplate();
                        this.transceivers.forEach(function(transceiver) {
                            var commonCapabilities = self._getCommonCapabilities(transceiver.localCapabilities, transceiver.remoteCapabilities);
                            sdp += SDPUtils.writeMediaSection(transceiver, commonCapabilities, "answer", self.localStreams[0]);
                        });
                        var desc = new RTCSessionDescription({type:"answer", sdp:sdp});
                        if (arguments.length && typeof arguments[0] === "function") {
                            window.setTimeout(arguments[0], 0, desc);
                        }
                        return Promise.resolve(desc);
                    };
                    window.RTCPeerConnection.prototype.addIceCandidate = function(candidate) {
                        var mLineIndex = candidate.sdpMLineIndex;
                        if (candidate.sdpMid) {
                            for (var i = 0;i < this.transceivers.length;i++) {
                                if (this.transceivers[i].mid === candidate.sdpMid) {
                                    mLineIndex = i;
                                    break;
                                }
                            }
                        }
                        var transceiver = this.transceivers[mLineIndex];
                        if (transceiver) {
                            var cand = Object.keys(candidate.candidate).length > 0 ? SDPUtils.parseCandidate(candidate.candidate) : {};
                            if (cand.protocol === "tcp" && cand.port === 0) {
                                return;
                            }
                            if (cand.component !== "1") {
                                return;
                            }
                            if (cand.type === "endOfCandidates") {
                                cand = {};
                            }
                            transceiver.iceTransport.addRemoteCandidate(cand);
                        }
                        if (arguments.length > 1 && typeof arguments[1] === "function") {
                            window.setTimeout(arguments[1], 0);
                        }
                        return Promise.resolve();
                    };
                    window.RTCPeerConnection.prototype.getStats = function() {
                        var promises = [];
                        this.transceivers.forEach(function(transceiver) {
                            ["rtpSender", "rtpReceiver", "iceGatherer", "iceTransport", "dtlsTransport"].forEach(function(method) {
                                if (transceiver[method]) {
                                    promises.push(transceiver[method].getStats());
                                }
                            });
                        });
                        var cb = arguments.length > 1 && typeof arguments[1] === "function" && arguments[1];
                        return new Promise(function(resolve) {
                            var results = {};
                            Promise.all(promises).then(function(res) {
                                res.forEach(function(result) {
                                    Object.keys(result).forEach(function(id) {
                                        results[id] = result[id];
                                    });
                                });
                                if (cb) {
                                    window.setTimeout(cb, 0, results);
                                }
                                resolve(results);
                            });
                        });
                    };
                }
            } else {
                webrtcUtils.log("Browser does not appear to be WebRTC-capable");
            }
        }
    }
}
function requestUserMedia(constraints) {
    return new Promise(function(resolve, reject) {
        getUserMedia(constraints, resolve, reject);
    });
}
var webrtcTesting = {};
try {
    Object.defineProperty(webrtcTesting, "version", {set:function(version) {
        webrtcDetectedVersion = version;
    }});
} catch (e) {
}
if (typeof module !== "undefined") {
    var RTCPeerConnection;
    var RTCIceCandidate;
    var RTCSessionDescription;
    if (typeof window !== "undefined") {
        RTCPeerConnection = window.RTCPeerConnection;
        RTCIceCandidate = window.RTCIceCandidate;
        RTCSessionDescription = window.RTCSessionDescription;
    }
    module.exports = {RTCPeerConnection:RTCPeerConnection, RTCIceCandidate:RTCIceCandidate, RTCSessionDescription:RTCSessionDescription, getUserMedia:getUserMedia, attachMediaStream:attachMediaStream, reattachMediaStream:reattachMediaStream, webrtcDetectedBrowser:webrtcDetectedBrowser, webrtcDetectedVersion:webrtcDetectedVersion, webrtcMinimumVersion:webrtcMinimumVersion, webrtcTesting:webrtcTesting, webrtcUtils:webrtcUtils};
} else {
    if (typeof require === "function" && typeof define === "function") {
        define([], function() {
            return {RTCPeerConnection:window.RTCPeerConnection, RTCIceCandidate:window.RTCIceCandidate, RTCSessionDescription:window.RTCSessionDescription, getUserMedia:getUserMedia, attachMediaStream:attachMediaStream, reattachMediaStream:reattachMediaStream, webrtcDetectedBrowser:webrtcDetectedBrowser, webrtcDetectedVersion:webrtcDetectedVersion, webrtcMinimumVersion:webrtcMinimumVersion, webrtcTesting:webrtcTesting, webrtcUtils:webrtcUtils};
        });
    }
}
;var remoteVideo = $("#remote-video");
var UI_CONSTANTS = {confirmJoinButton:"#confirm-join-button", confirmJoinDiv:"#confirm-join-div", confirmJoinRoomSpan:"#confirm-join-room-span", fullscreenSvg:"#fullscreen", hangupSvg:"#hangup", icons:"#icons", infoDiv:"#info-div", localVideo:"#local-video", miniVideo:"#mini-video", muteAudioSvg:"#mute-audio", muteVideoSvg:"#mute-video", newRoomButton:"#new-room-button", newRoomLink:"#new-room-link", remoteVideo:"#remote-video", rejoinButton:"#rejoin-button", rejoinDiv:"#rejoin-div", rejoinLink:"#rejoin-link",
    roomLinkHref:"#room-link-href", roomSelectionDiv:"#room-selection", roomSelectionInput:"#room-id-input", roomSelectionInputLabel:"#room-id-input-label", roomSelectionJoinButton:"#join-button", roomSelectionRandomButton:"#random-button", roomSelectionRecentList:"#recent-rooms-list", sharingDiv:"#sharing-div", statusDiv:"#status-div", videosDiv:"#videos"};
var AppController = function(loadingParams) {
    trace("Initializing; server= " + loadingParams.roomServer + ".");
    trace("Initializing; room=" + loadingParams.roomId + ".");
    this.hangupSvg_ = $(UI_CONSTANTS.hangupSvg);
    this.icons_ = $(UI_CONSTANTS.icons);
    this.localVideo_ = $(UI_CONSTANTS.localVideo);
    this.miniVideo_ = $(UI_CONSTANTS.miniVideo);
    this.sharingDiv_ = $(UI_CONSTANTS.sharingDiv);
    this.statusDiv_ = $(UI_CONSTANTS.statusDiv);
    this.remoteVideo_ = $(UI_CONSTANTS.remoteVideo);
    this.videosDiv_ = $(UI_CONSTANTS.videosDiv);
    this.roomLinkHref_ = $(UI_CONSTANTS.roomLinkHref);
    this.rejoinDiv_ = $(UI_CONSTANTS.rejoinDiv);
    this.rejoinLink_ = $(UI_CONSTANTS.rejoinLink);
    this.newRoomLink_ = $(UI_CONSTANTS.newRoomLink);
    this.rejoinButton_ = $(UI_CONSTANTS.rejoinButton);
    this.newRoomButton_ = $(UI_CONSTANTS.newRoomButton);
    this.newRoomButton_.addEventListener("click", this.onNewRoomClick_.bind(this), false);
    this.rejoinButton_.addEventListener("click", this.onRejoinClick_.bind(this), false);
    this.muteAudioIconSet_ = new AppController.IconSet_(UI_CONSTANTS.muteAudioSvg);
    this.muteVideoIconSet_ = new AppController.IconSet_(UI_CONSTANTS.muteVideoSvg);
    this.fullscreenIconSet_ = new AppController.IconSet_(UI_CONSTANTS.fullscreenSvg);
    this.loadingParams_ = loadingParams;
    this.loadUrlParams_();
    var paramsPromise = Promise.resolve({});
    if (this.loadingParams_.paramsFunction) {
        paramsPromise = this.loadingParams_.paramsFunction();
    }
    Promise.resolve(paramsPromise).then(function(newParams) {
        if (newParams) {
            Object.keys(newParams).forEach(function(key) {
                this.loadingParams_[key] = newParams[key];
            }.bind(this));
        }
        this.roomLink_ = "";
        this.roomSelection_ = null;
        this.localStream_ = null;
        this.remoteVideoResetTimer_ = null;
        if (this.loadingParams_.roomId) {
            this.createCall_();
            if (!RoomSelection.matchRandomRoomPattern(this.loadingParams_.roomId)) {
                $(UI_CONSTANTS.confirmJoinRoomSpan).textContent = ' "' + this.loadingParams_.roomId + '"';
            }
            var confirmJoinDiv = $(UI_CONSTANTS.confirmJoinDiv);
            this.show_(confirmJoinDiv);
            $(UI_CONSTANTS.confirmJoinButton).onclick = function() {
                this.hide_(confirmJoinDiv);
                var recentlyUsedList = new RoomSelection.RecentlyUsedList;
                recentlyUsedList.pushRecentRoom(this.loadingParams_.roomId);
                this.finishCallSetup_(this.loadingParams_.roomId);
            }.bind(this);
            if (this.loadingParams_.bypassJoinConfirmation) {
                $(UI_CONSTANTS.confirmJoinButton).onclick();
            }
        } else {
            this.showRoomSelection_();
        }
    }.bind(this))["catch"](function(error) {
        trace("Error initializing: " + error.message);
    }.bind(this));
};
AppController.prototype.createCall_ = function() {
    this.call_ = new Call(this.loadingParams_);
    this.infoBox_ = new InfoBox($(UI_CONSTANTS.infoDiv), this.remoteVideo_, this.call_, this.loadingParams_.versionInfo);
    var roomErrors = this.loadingParams_.errorMessages;
    var roomWarnings = this.loadingParams_.warningMessages;
    if (roomErrors && roomErrors.length > 0) {
        for (var i = 0;i < roomErrors.length;++i) {
            this.infoBox_.pushErrorMessage(roomErrors[i]);
        }
        return;
    } else {
        if (roomWarnings && roomWarnings.length > 0) {
            for (var j = 0;j < roomWarnings.length;++j) {
                this.infoBox_.pushWarningMessage(roomWarnings[j]);
            }
        }
    }
    this.call_.onremotehangup = this.onRemoteHangup_.bind(this);
    this.call_.onremotesdpset = this.onRemoteSdpSet_.bind(this);
    this.call_.onremotestreamadded = this.onRemoteStreamAdded_.bind(this);
    this.call_.onlocalstreamadded = this.onLocalStreamAdded_.bind(this);
    this.call_.onsignalingstatechange = this.infoBox_.updateInfoDiv.bind(this.infoBox_);
    this.call_.oniceconnectionstatechange = this.infoBox_.updateInfoDiv.bind(this.infoBox_);
    this.call_.onnewicecandidate = this.infoBox_.recordIceCandidateTypes.bind(this.infoBox_);
    this.call_.onerror = this.displayError_.bind(this);
    this.call_.onstatusmessage = this.displayStatus_.bind(this);
    this.call_.oncallerstarted = this.displaySharingInfo_.bind(this);
};
AppController.prototype.showRoomSelection_ = function() {
    var roomSelectionDiv = $(UI_CONSTANTS.roomSelectionDiv);
    this.roomSelection_ = new RoomSelection(roomSelectionDiv, UI_CONSTANTS);
    this.show_(roomSelectionDiv);
    this.roomSelection_.onRoomSelected = function(roomName) {
        this.hide_(roomSelectionDiv);
        this.createCall_();
        this.finishCallSetup_(roomName);
        this.roomSelection_.removeEventListeners();
        this.roomSelection_ = null;
        if (this.localStream_) {
            this.attachLocalStream_();
        }
    }.bind(this);
};
AppController.prototype.finishCallSetup_ = function(roomId) {
    this.call_.start(roomId);
    this.iconEventSetup_();
    document.onkeypress = this.onKeyPress_.bind(this);
    window.onmousemove = this.showIcons_.bind(this);
    $(UI_CONSTANTS.muteAudioSvg).onclick = this.toggleAudioMute_.bind(this);
    $(UI_CONSTANTS.muteVideoSvg).onclick = this.toggleVideoMute_.bind(this);
    $(UI_CONSTANTS.fullscreenSvg).onclick = this.toggleFullScreen_.bind(this);
    $(UI_CONSTANTS.hangupSvg).onclick = this.hangup_.bind(this);
    setUpFullScreen();
    if (!isChromeApp()) {
        window.onbeforeunload = function() {
            this.call_.hangup(false);
        }.bind(this);
        window.onpopstate = function(event) {
            if (!event.state) {
                trace("Reloading main page.");
                location.href = location.origin;
            } else {
                if (event.state.roomLink) {
                    location.href = event.state.roomLink;
                }
            }
        };
    }
};
AppController.prototype.hangup_ = function() {
    trace("Hanging up.");
    this.hide_(this.icons_);
    this.displayStatus_("Hanging up");
    this.transitionToDone_();
    this.call_.hangup(true);
};
AppController.prototype.onRemoteHangup_ = function() {
    this.displayStatus_("The remote side hung up.");
    this.transitionToWaiting_();
    this.call_.onRemoteHangup();
};
AppController.prototype.onRemoteSdpSet_ = function(hasRemoteVideo) {
    if (hasRemoteVideo) {
        trace("Waiting for remote video.");
        this.waitForRemoteVideo_();
    } else {
        trace("No remote video stream; not waiting for media to arrive.");
        this.transitionToActive_();
    }
};
AppController.prototype.waitForRemoteVideo_ = function() {
    if (this.remoteVideo_.readyState >= 2) {
        trace("Remote video started; currentTime: " + this.remoteVideo_.currentTime);
        this.transitionToActive_();
    } else {
        this.remoteVideo_.oncanplay = this.waitForRemoteVideo_.bind(this);
    }
};
AppController.prototype.onRemoteStreamAdded_ = function(stream) {
    this.deactivate_(this.sharingDiv_);
    trace("Remote stream added.");
    attachMediaStream(this.remoteVideo_, stream);
    if (this.remoteVideoResetTimer_) {
        clearTimeout(this.remoteVideoResetTimer_);
        this.remoteVideoResetTimer_ = null;
    }
};
AppController.prototype.onLocalStreamAdded_ = function(stream) {
    trace("User has granted access to local media.");
    this.localStream_ = stream;
    if (!this.roomSelection_) {
        this.attachLocalStream_();
    }
};
AppController.prototype.attachLocalStream_ = function() {
    trace("Attaching local stream.");
    attachMediaStream(this.localVideo_, this.localStream_);
    this.displayStatus_("");
    this.activate_(this.localVideo_);
    this.show_(this.icons_);
    if (this.localStream_.getVideoTracks().length === 0) {
        this.hide_($(UI_CONSTANTS.muteVideoSvg));
    }
    if (this.localStream_.getAudioTracks().length === 0) {
        this.hide_($(UI_CONSTANTS.muteAudioSvg));
    }
};
AppController.prototype.transitionToActive_ = function() {
    this.remoteVideo_.oncanplay = undefined;
    var connectTime = window.performance.now();
    this.infoBox_.setSetupTimes(this.call_.startTime, connectTime);
    this.infoBox_.updateInfoDiv();
    trace("Call setup time: " + (connectTime - this.call_.startTime).toFixed(0) + "ms.");
    trace("reattachMediaStream: " + this.localVideo_.src);
    reattachMediaStream(this.miniVideo_, this.localVideo_);
    this.activate_(this.remoteVideo_);
    this.activate_(this.miniVideo_);
    this.deactivate_(this.localVideo_);
    this.localVideo_.src = "";
    this.activate_(this.videosDiv_);
    this.show_(this.hangupSvg_);
    this.displayStatus_("");
};
AppController.prototype.transitionToWaiting_ = function() {
    this.remoteVideo_.oncanplay = undefined;
    this.hide_(this.hangupSvg_);
    this.deactivate_(this.videosDiv_);
    if (!this.remoteVideoResetTimer_) {
        this.remoteVideoResetTimer_ = setTimeout(function() {
            this.remoteVideoResetTimer_ = null;
            trace("Resetting remoteVideo src after transitioning to waiting.");
            this.remoteVideo_.src = "";
        }.bind(this), 800);
    }
    this.localVideo_.src = this.miniVideo_.src;
    this.activate_(this.localVideo_);
    this.deactivate_(this.remoteVideo_);
    this.deactivate_(this.miniVideo_);
};
AppController.prototype.transitionToDone_ = function() {
    this.remoteVideo_.oncanplay = undefined;
    this.deactivate_(this.localVideo_);
    this.deactivate_(this.remoteVideo_);
    this.deactivate_(this.miniVideo_);
    this.hide_(this.hangupSvg_);
    this.activate_(this.rejoinDiv_);
    this.show_(this.rejoinDiv_);
    this.displayStatus_("");
};
AppController.prototype.onRejoinClick_ = function() {
    this.deactivate_(this.rejoinDiv_);
    this.hide_(this.rejoinDiv_);
    this.call_.restart();
};
AppController.prototype.onNewRoomClick_ = function() {
    this.deactivate_(this.rejoinDiv_);
    this.hide_(this.rejoinDiv_);
    this.showRoomSelection_();
};
AppController.prototype.onKeyPress_ = function(event) {
    switch(String.fromCharCode(event.charCode)) {
        case " ":
            ;
        case "m":
            if (this.call_) {
                this.call_.toggleAudioMute();
                this.muteAudioIconSet_.toggle();
            }
            return false;
        case "c":
            if (this.call_) {
                this.call_.toggleVideoMute();
                this.muteVideoIconSet_.toggle();
            }
            return false;
        case "f":
            this.toggleFullScreen_();
            return false;
        case "i":
            this.infoBox_.toggleInfoDiv();
            return false;
        case "q":
            this.hangup_();
            return false;
        default:
            return;
    }
};
AppController.prototype.pushCallNavigation_ = function(roomId, roomLink) {
    if (!isChromeApp()) {
        window.history.pushState({"roomId":roomId, "roomLink":roomLink}, roomId, roomLink);
    }
};
AppController.prototype.displaySharingInfo_ = function(roomId, roomLink) {
    this.roomLinkHref_.href = roomLink;
    this.roomLinkHref_.text = roomLink;
    this.roomLink_ = roomLink;
    this.pushCallNavigation_(roomId, roomLink);
    this.activate_(this.sharingDiv_);
};
AppController.prototype.displayStatus_ = function(status) {
    if (status === "") {
        this.deactivate_(this.statusDiv_);
    } else {
        this.activate_(this.statusDiv_);
    }
    this.statusDiv_.innerHTML = status;
};
AppController.prototype.displayError_ = function(error) {
    trace(error);
    this.infoBox_.pushErrorMessage(error);
};
AppController.prototype.toggleAudioMute_ = function() {
    this.call_.toggleAudioMute();
    this.muteAudioIconSet_.toggle();
};
AppController.prototype.toggleVideoMute_ = function() {
    this.call_.toggleVideoMute();
    this.muteVideoIconSet_.toggle();
};
AppController.prototype.toggleFullScreen_ = function() {
    if (isFullScreen()) {
        trace("Exiting fullscreen.");
        document.querySelector("svg#fullscreen title").textContent = "Enter fullscreen";
        document.cancelFullScreen();
    } else {
        trace("Entering fullscreen.");
        document.querySelector("svg#fullscreen title").textContent = "Exit fullscreen";
        document.body.requestFullScreen();
    }
    this.fullscreenIconSet_.toggle();
};
AppController.prototype.hide_ = function(element) {
    element.classList.add("hidden");
};
AppController.prototype.show_ = function(element) {
    element.classList.remove("hidden");
};
AppController.prototype.activate_ = function(element) {
    element.classList.add("active");
};
AppController.prototype.deactivate_ = function(element) {
    element.classList.remove("active");
};
AppController.prototype.showIcons_ = function() {
    if (!this.icons_.classList.contains("active")) {
        this.activate_(this.icons_);
        this.setIconTimeout_();
    }
};
AppController.prototype.hideIcons_ = function() {
    if (this.icons_.classList.contains("active")) {
        this.deactivate_(this.icons_);
    }
};
AppController.prototype.setIconTimeout_ = function() {
    if (this.hideIconsAfterTimeout) {
        window.clearTimeout.bind(this, this.hideIconsAfterTimeout);
    }
    this.hideIconsAfterTimeout = window.setTimeout(function() {
        this.hideIcons_();
    }.bind(this), 5E3);
};
AppController.prototype.iconEventSetup_ = function() {
    this.icons_.onmouseenter = function() {
        window.clearTimeout(this.hideIconsAfterTimeout);
    }.bind(this);
    this.icons_.onmouseleave = function() {
        this.setIconTimeout_();
    }.bind(this);
};
AppController.prototype.loadUrlParams_ = function() {
    var DEFAULT_VIDEO_CODEC = "VP9";
    var urlParams = queryStringToDictionary(window.location.search);
    this.loadingParams_.audioSendBitrate = urlParams["asbr"];
    this.loadingParams_.audioSendCodec = urlParams["asc"];
    this.loadingParams_.audioRecvBitrate = urlParams["arbr"];
    this.loadingParams_.audioRecvCodec = urlParams["arc"];
    this.loadingParams_.opusMaxPbr = urlParams["opusmaxpbr"];
    this.loadingParams_.opusFec = urlParams["opusfec"];
    this.loadingParams_.opusDtx = urlParams["opusdtx"];
    this.loadingParams_.opusStereo = urlParams["stereo"];
    this.loadingParams_.videoSendBitrate = urlParams["vsbr"];
    this.loadingParams_.videoSendInitialBitrate = urlParams["vsibr"];
    this.loadingParams_.videoSendCodec = urlParams["vsc"];
    this.loadingParams_.videoRecvBitrate = urlParams["vrbr"];
    this.loadingParams_.videoRecvCodec = urlParams["vrc"] || DEFAULT_VIDEO_CODEC;
};
AppController.IconSet_ = function(iconSelector) {
    this.iconElement = document.querySelector(iconSelector);
};
AppController.IconSet_.prototype.toggle = function() {
    if (this.iconElement.classList.contains("on")) {
        this.iconElement.classList.remove("on");
    } else {
        this.iconElement.classList.add("on");
    }
};
var Call = function(params) {
    this.params_ = params;
    this.roomServer_ = params.roomServer || "";
    this.channel_ = new SignalingChannel(params.wssUrl, params.wssPostUrl);
    this.channel_.onmessage = this.onRecvSignalingChannelMessage_.bind(this);
    this.pcClient_ = null;
    this.localStream_ = null;
    this.startTime = null;
    this.oncallerstarted = null;
    this.onerror = null;
    this.oniceconnectionstatechange = null;
    this.onlocalstreamadded = null;
    this.onnewicecandidate = null;
    this.onremotehangup = null;
    this.onremotesdpset = null;
    this.onremotestreamadded = null;
    this.onsignalingstatechange = null;
    this.onstatusmessage = null;
    this.getMediaPromise_ = null;
    this.getIceServersPromise_ = null;
    this.requestMediaAndIceServers_();
};
Call.prototype.requestMediaAndIceServers_ = function() {
    this.getMediaPromise_ = this.maybeGetMedia_();
    this.getIceServersPromise_ = this.maybeGetIceServers_();
};
Call.prototype.isInitiator = function() {
    return this.params_.isInitiator;
};
Call.prototype.start = function(roomId) {
    this.connectToRoom_(roomId);
    if (this.params_.isLoopback) {
        setupLoopback(this.params_.wssUrl, roomId);
    }
};
Call.prototype.queueCleanupMessages_ = function() {
    apprtc.windowPort.sendMessage({action:Constants.QUEUEADD_ACTION, queueMessage:{action:Constants.XHR_ACTION, method:"POST", url:this.getLeaveUrl_(), body:null}});
    apprtc.windowPort.sendMessage({action:Constants.QUEUEADD_ACTION, queueMessage:{action:Constants.WS_ACTION, wsAction:Constants.WS_SEND_ACTION, data:JSON.stringify({cmd:"send", msg:JSON.stringify({type:"bye"})})}});
    apprtc.windowPort.sendMessage({action:Constants.QUEUEADD_ACTION, queueMessage:{action:Constants.XHR_ACTION, method:"DELETE", url:this.channel_.getWssPostUrl(), body:null}});
};
Call.prototype.clearCleanupQueue_ = function() {
    apprtc.windowPort.sendMessage({action:Constants.QUEUECLEAR_ACTION});
};
Call.prototype.restart = function() {
    this.requestMediaAndIceServers_();
    this.start(this.params_.previousRoomId);
};
Call.prototype.hangup = function(async) {
    this.startTime = null;
    if (isChromeApp()) {
        this.clearCleanupQueue_();
    }
    if (this.localStream_) {
        if (typeof this.localStream_.getTracks === "undefined") {
            this.localStream_.stop();
        } else {
            this.localStream_.getTracks().forEach(function(track) {
                track.stop();
            });
        }
        this.localStream_ = null;
    }
    if (!this.params_.roomId) {
        return;
    }
    if (this.pcClient_) {
        this.pcClient_.close();
        this.pcClient_ = null;
    }
    var steps = [];
    steps.push({step:function() {
        var path = this.getLeaveUrl_();
        return sendUrlRequest("POST", path, async);
    }.bind(this), errorString:"Error sending /leave:"});
    steps.push({step:function() {
        this.channel_.send(JSON.stringify({type:"bye"}));
    }.bind(this), errorString:"Error sending bye:"});
    steps.push({step:function() {
        return this.channel_.close(async);
    }.bind(this), errorString:"Error closing signaling channel:"});
    steps.push({step:function() {
        this.params_.previousRoomId = this.params_.roomId;
        this.params_.roomId = null;
        this.params_.clientId = null;
    }.bind(this), errorString:"Error setting params:"});
    if (async) {
        var errorHandler = function(errorString, error) {
            trace(errorString + " " + error.message);
        };
        var promise = Promise.resolve();
        for (var i = 0;i < steps.length;++i) {
            promise = promise.then(steps[i].step)["catch"](errorHandler.bind(this, steps[i].errorString));
        }
        return promise;
    } else {
        var executeStep = function(executor, errorString) {
            try {
                executor();
            } catch (ex) {
                trace(errorString + " " + ex);
            }
        };
        for (var j = 0;j < steps.length;++j) {
            executeStep(steps[j].step, steps[j].errorString);
        }
        if (this.params_.roomId !== null || this.params_.clientId !== null) {
            trace("ERROR: sync cleanup tasks did not complete successfully.");
        } else {
            trace("Cleanup completed.");
        }
        return Promise.resolve();
    }
};
Call.prototype.getLeaveUrl_ = function() {
    return this.roomServer_ + "/leave/" + this.params_.roomId + "/" + this.params_.clientId;
};
Call.prototype.onRemoteHangup = function() {
    this.startTime = null;
    this.params_.isInitiator = true;
    if (this.pcClient_) {
        this.pcClient_.close();
        this.pcClient_ = null;
    }
    this.startSignaling_();
};
Call.prototype.getPeerConnectionStates = function() {
    if (!this.pcClient_) {
        return null;
    }
    return this.pcClient_.getPeerConnectionStates();
};
Call.prototype.getPeerConnectionStats = function(callback) {
    if (!this.pcClient_) {
        return;
    }
    this.pcClient_.getPeerConnectionStats(callback);
};
Call.prototype.toggleVideoMute = function() {
    var videoTracks = this.localStream_.getVideoTracks();
    if (videoTracks.length === 0) {
        trace("No local video available.");
        return;
    }
    trace("Toggling video mute state.");
    for (var i = 0;i < videoTracks.length;++i) {
        videoTracks[i].enabled = !videoTracks[i].enabled;
    }
    trace("Video " + (videoTracks[0].enabled ? "unmuted." : "muted."));
};
Call.prototype.toggleAudioMute = function() {
    var audioTracks = this.localStream_.getAudioTracks();
    if (audioTracks.length === 0) {
        trace("No local audio available.");
        return;
    }
    trace("Toggling audio mute state.");
    for (var i = 0;i < audioTracks.length;++i) {
        audioTracks[i].enabled = !audioTracks[i].enabled;
    }
    trace("Audio " + (audioTracks[0].enabled ? "unmuted." : "muted."));
};
Call.prototype.connectToRoom_ = function(roomId) {
    this.params_.roomId = roomId;
    var channelPromise = this.channel_.open()["catch"](function(error) {
        this.onError_("WebSocket open error: " + error.message);
        return Promise.reject(error);
    }.bind(this));
    var joinPromise = this.joinRoom_().then(function(roomParams) {
        this.params_.clientId = roomParams.client_id;
        this.params_.roomId = roomParams.room_id;
        this.params_.roomLink = roomParams.room_link;
        this.params_.isInitiator = roomParams.is_initiator === "true";
        this.params_.messages = roomParams.messages;
    }.bind(this))["catch"](function(error) {
        this.onError_("Room server join error: " + error.message);
        return Promise.reject(error);
    }.bind(this));
    Promise.all([channelPromise, joinPromise]).then(function() {
        this.channel_.register(this.params_.roomId, this.params_.clientId);
        Promise.all([this.getIceServersPromise_, this.getMediaPromise_]).then(function() {
            this.startSignaling_();
            if (isChromeApp()) {
                this.queueCleanupMessages_();
            }
        }.bind(this))["catch"](function(error) {
            this.onError_("Failed to start signaling: " + error.message);
        }.bind(this));
    }.bind(this))["catch"](function(error) {
        this.onError_("WebSocket register error: " + error.message);
    }.bind(this));
};
Call.prototype.maybeGetMedia_ = function() {
    var needStream = this.params_.mediaConstraints.audio !== false || this.params_.mediaConstraints.video !== false;
    var mediaPromise = null;
    if (needStream) {
        var mediaConstraints = this.params_.mediaConstraints;
        mediaPromise = requestUserMedia(mediaConstraints).then(function(stream) {
            trace("Got access to local media with mediaConstraints:\n" + "  '" + JSON.stringify(mediaConstraints) + "'");
            this.onUserMediaSuccess_(stream);
        }.bind(this))["catch"](function(error) {
            this.onError_("Error getting user media: " + error.message);
            this.onUserMediaError_(error);
        }.bind(this));
    } else {
        mediaPromise = Promise.resolve();
    }
    return mediaPromise;
};
Call.prototype.maybeGetIceServers_ = function() {
    var shouldRequestIceServers = this.params_.iceServerRequestUrl && this.params_.iceServerRequestUrl.length > 0;
    var iceServerPromise = null;
    if (shouldRequestIceServers) {
        var requestUrl = this.params_.iceServerRequestUrl;
        iceServerPromise = requestIceServers(requestUrl, this.params_.iceServerTransports).then(function(iceServers) {
            var servers = this.params_.peerConnectionConfig.iceServers;
            this.params_.peerConnectionConfig.iceServers = servers.concat(iceServers);
        }.bind(this))["catch"](function(error) {
            if (this.onstatusmessage) {
                var subject = encodeURIComponent("AppRTC demo ICE servers not working");
                this.onstatusmessage("No TURN server; unlikely that media will traverse networks. " + "If this persists please " + '<a href="mailto:discuss-webrtc@googlegroups.com?' + "subject=" + subject + '">' + "report it to discuss-webrtc@googlegroups.com</a>.");
            }
            trace(error.message);
        }.bind(this));
    } else {
        iceServerPromise = Promise.resolve();
    }
    return iceServerPromise;
};
Call.prototype.onUserMediaSuccess_ = function(stream) {
    this.localStream_ = stream;
    if (this.onlocalstreamadded) {
        this.onlocalstreamadded(stream);
    }
};
Call.prototype.onUserMediaError_ = function(error) {
    var errorMessage = "Failed to get access to local media. Error name was " + error.name + ". Continuing without sending a stream.";
    this.onError_("getUserMedia error: " + errorMessage);
    alert(errorMessage);
};
Call.prototype.maybeCreatePcClientAsync_ = function() {
    return new Promise(function(resolve, reject) {
        if (this.pcClient_) {
            resolve();
            return;
        }
        if (typeof RTCPeerConnection.generateCertificate === "function") {
            var certParams = {name:"ECDSA", namedCurve:"P-256"};
            RTCPeerConnection.generateCertificate(certParams).then(function(cert) {
                trace("ECDSA certificate generated successfully.");
                this.params_.peerConnectionConfig.certificates = [cert];
                this.createPcClient_();
                resolve();
            }.bind(this))["catch"](function(error) {
                trace("ECDSA certificate generation failed.");
                reject(error);
            });
        } else {
            this.createPcClient_();
            resolve();
        }
    }.bind(this));
};
Call.prototype.createPcClient_ = function() {
    this.pcClient_ = new PeerConnectionClient(this.params_, this.startTime);
    this.pcClient_.onsignalingmessage = this.sendSignalingMessage_.bind(this);
    this.pcClient_.onremotehangup = this.onremotehangup;
    this.pcClient_.onremotesdpset = this.onremotesdpset;
    this.pcClient_.onremotestreamadded = this.onremotestreamadded;
    this.pcClient_.onsignalingstatechange = this.onsignalingstatechange;
    this.pcClient_.oniceconnectionstatechange = this.oniceconnectionstatechange;
    this.pcClient_.onnewicecandidate = this.onnewicecandidate;
    this.pcClient_.onerror = this.onerror;
    trace("Created PeerConnectionClient");
};
Call.prototype.startSignaling_ = function() {
    trace("Starting signaling.");
    if (this.isInitiator() && this.oncallerstarted) {
        this.oncallerstarted(this.params_.roomId, this.params_.roomLink);
    }
    this.startTime = window.performance.now();
    this.maybeCreatePcClientAsync_().then(function() {
        if (this.localStream_) {
            trace("Adding local stream.");
            this.pcClient_.addStream(this.localStream_);
        }
        if (this.params_.isInitiator) {
            this.pcClient_.startAsCaller(this.params_.offerOptions);
        } else {
            this.pcClient_.startAsCallee(this.params_.messages);
        }
    }.bind(this))["catch"](function(e) {
        this.onError_("Create PeerConnection exception: " + e.message);
        alert("Cannot create RTCPeerConnection: " + e.message);
    }.bind(this));
};
Call.prototype.joinRoom_ = function() {
    return new Promise(function(resolve, reject) {
        if (!this.params_.roomId) {
            reject(Error("Missing room id."));
        }
        var path = this.roomServer_ + "/join/" + this.params_.roomId + window.location.search;
        sendAsyncUrlRequest("POST", path).then(function(response) {
            var responseObj = parseJSON(response);
            if (!responseObj) {
                reject(Error("Error parsing response JSON."));
                return;
            }
            if (responseObj.result !== "SUCCESS") {
                reject(Error("Registration error: " + responseObj.result));
                return;
            }
            trace("Joined the room.");
            resolve(responseObj.params);
        }.bind(this))["catch"](function(error) {
            reject(Error("Failed to join the room: " + error.message));
            return;
        }.bind(this));
    }.bind(this));
};
Call.prototype.onRecvSignalingChannelMessage_ = function(msg) {
    this.maybeCreatePcClientAsync_().then(this.pcClient_.receiveSignalingMessage(msg));
};
Call.prototype.sendSignalingMessage_ = function(message) {
    var msgString = JSON.stringify(message);
    if (this.params_.isInitiator) {
        var path = this.roomServer_ + "/message/" + this.params_.roomId + "/" + this.params_.clientId + window.location.search;
        var xhr = new XMLHttpRequest;
        xhr.open("POST", path, true);
        xhr.send(msgString);
        trace("C->GAE: " + msgString);
    } else {
        this.channel_.send(msgString);
    }
};
Call.prototype.onError_ = function(message) {
    if (this.onerror) {
        this.onerror(message);
    }
};
var Constants = {WS_ACTION:"ws", XHR_ACTION:"xhr", QUEUEADD_ACTION:"addToQueue", QUEUECLEAR_ACTION:"clearQueue", EVENT_ACTION:"event", WS_CREATE_ACTION:"create", WS_EVENT_ONERROR:"onerror", WS_EVENT_ONMESSAGE:"onmessage", WS_EVENT_ONOPEN:"onopen", WS_EVENT_ONCLOSE:"onclose", WS_EVENT_SENDERROR:"onsenderror", WS_SEND_ACTION:"send", WS_CLOSE_ACTION:"close"};
var InfoBox = function(infoDiv, remoteVideo, call, versionInfo) {
    this.infoDiv_ = infoDiv;
    this.remoteVideo_ = remoteVideo;
    this.call_ = call;
    this.versionInfo_ = versionInfo;
    this.errorMessages_ = [];
    this.warningMessages_ = [];
    this.startTime_ = null;
    this.connectTime_ = null;
    this.stats_ = null;
    this.prevStats_ = null;
    this.getStatsTimer_ = null;
    this.iceCandidateTypes_ = {Local:{}, Remote:{}};
};
InfoBox.prototype.recordIceCandidateTypes = function(location, candidate) {
    var type = iceCandidateType(candidate);
    var types = this.iceCandidateTypes_[location];
    if (!types[type]) {
        types[type] = 1;
    } else {
        ++types[type];
    }
    this.updateInfoDiv();
};
InfoBox.prototype.pushErrorMessage = function(msg) {
    this.errorMessages_.push(msg);
    this.updateInfoDiv();
    this.showInfoDiv();
};
InfoBox.prototype.pushWarningMessage = function(msg) {
    this.warningMessages_.push(msg);
    this.updateInfoDiv();
    this.showInfoDiv();
};
InfoBox.prototype.setSetupTimes = function(startTime, connectTime) {
    this.startTime_ = startTime;
    this.connectTime_ = connectTime;
};
InfoBox.prototype.showInfoDiv = function() {
    this.getStatsTimer_ = setInterval(this.refreshStats_.bind(this), 1E3);
    this.refreshStats_();
    this.infoDiv_.classList.add("active");
};
InfoBox.prototype.toggleInfoDiv = function() {
    if (this.infoDiv_.classList.contains("active")) {
        clearInterval(this.getStatsTimer_);
        this.infoDiv_.classList.remove("active");
    } else {
        this.showInfoDiv();
    }
};
InfoBox.prototype.refreshStats_ = function() {
    this.call_.getPeerConnectionStats(function(response) {
        this.prevStats_ = this.stats_;
        this.stats_ = response.result();
        this.updateInfoDiv();
    }.bind(this));
};
InfoBox.prototype.updateInfoDiv = function() {
    var contents = '<pre id="info-box-stats" style="line-height: initial">';
    if (this.stats_) {
        var states = this.call_.getPeerConnectionStates();
        if (!states) {
            return;
        }
        contents += this.buildLine_("States");
        contents += this.buildLine_("Signaling", states.signalingState);
        contents += this.buildLine_("Gathering", states.iceGatheringState);
        contents += this.buildLine_("Connection", states.iceConnectionState);
        for (var endpoint in this.iceCandidateTypes_) {
            var types = [];
            for (var type in this.iceCandidateTypes_[endpoint]) {
                types.push(type + ":" + this.iceCandidateTypes_[endpoint][type]);
            }
            contents += this.buildLine_(endpoint, types.join(" "));
        }
        var activeCandPair = getStatsReport(this.stats_, "googCandidatePair", "googActiveConnection", "true");
        var localAddr;
        var remoteAddr;
        var localAddrType;
        var remoteAddrType;
        if (activeCandPair) {
            localAddr = activeCandPair.stat("googLocalAddress");
            remoteAddr = activeCandPair.stat("googRemoteAddress");
            localAddrType = activeCandPair.stat("googLocalCandidateType");
            remoteAddrType = activeCandPair.stat("googRemoteCandidateType");
        }
        if (localAddr && remoteAddr) {
            var localCandId = activeCandPair.stat("localCandidateId");
            var localCand;
            var localTypePref;
            if (localCandId) {
                localCand = getStatsReport(this.stats_, "localcandidate", "id", localCandId);
                if (localCand) {
                    localTypePref = localCand.stat("priority") >> 24;
                }
            }
            contents += this.buildLine_("LocalAddr", localAddr + " (" + localAddrType + (localTypePref !== undefined ? " " + formatTypePreference(localTypePref) : "") + ")");
            contents += this.buildLine_("RemoteAddr", remoteAddr + " (" + remoteAddrType + ")");
        }
        contents += this.buildLine_();
        contents += this.buildStatsSection_();
    }
    if (this.errorMessages_.length > 0 || this.warningMessages_.length > 0) {
        contents += this.buildLine_("\nMessages");
        if (this.errorMessages_.length) {
            this.infoDiv_.classList.add("warning");
            for (var i = 0;i !== this.errorMessages_.length;++i) {
                contents += this.errorMessages_[i] + "\n";
            }
        } else {
            this.infoDiv_.classList.add("active");
            for (var j = 0;j !== this.warningMessages_.length;++j) {
                contents += this.warningMessages_[j] + "\n";
            }
        }
    } else {
        this.infoDiv_.classList.remove("warning");
    }
    if (this.versionInfo_) {
        contents += this.buildLine_();
        contents += this.buildLine_("Version");
        for (var key in this.versionInfo_) {
            contents += this.buildLine_(key, this.versionInfo_[key]);
        }
    }
    contents += "</pre>";
    if (this.infoDiv_.innerHTML !== contents) {
        this.infoDiv_.innerHTML = contents;
    }
};
InfoBox.prototype.buildStatsSection_ = function() {
    var contents = this.buildLine_("Stats");
    var rtt = extractStatAsInt(this.stats_, "ssrc", "googRtt");
    var captureStart = extractStatAsInt(this.stats_, "ssrc", "googCaptureStartNtpTimeMs");
    var e2eDelay = computeE2EDelay(captureStart, this.remoteVideo_.currentTime);
    if (this.endTime_ !== null) {
        contents += this.buildLine_("Call time", InfoBox.formatInterval_(window.performance.now() - this.connectTime_));
        contents += this.buildLine_("Setup time", InfoBox.formatMsec_(this.connectTime_ - this.startTime_));
    }
    if (rtt !== null) {
        contents += this.buildLine_("RTT", InfoBox.formatMsec_(rtt));
    }
    if (e2eDelay !== null) {
        contents += this.buildLine_("End to end", InfoBox.formatMsec_(e2eDelay));
    }
    var txAudio = getStatsReport(this.stats_, "ssrc", "audioInputLevel");
    var rxAudio = getStatsReport(this.stats_, "ssrc", "audioOutputLevel");
    var txVideo = getStatsReport(this.stats_, "ssrc", "googFirsReceived");
    var rxVideo = getStatsReport(this.stats_, "ssrc", "googFirsSent");
    var txPrevAudio = getStatsReport(this.prevStats_, "ssrc", "audioInputLevel");
    var rxPrevAudio = getStatsReport(this.prevStats_, "ssrc", "audioOutputLevel");
    var txPrevVideo = getStatsReport(this.prevStats_, "ssrc", "googFirsReceived");
    var rxPrevVideo = getStatsReport(this.prevStats_, "ssrc", "googFirsSent");
    var txAudioCodec;
    var txAudioBitrate;
    var txAudioPacketRate;
    var rxAudioCodec;
    var rxAudioBitrate;
    var rxAudioPacketRate;
    var txVideoHeight;
    var txVideoFps;
    var txVideoCodec;
    var txVideoBitrate;
    var txVideoPacketRate;
    var rxVideoHeight;
    var rxVideoFps;
    var rxVideoCodec;
    var rxVideoBitrate;
    var rxVideoPacketRate;
    if (txAudio) {
        txAudioCodec = txAudio.stat("googCodecName");
        txAudioBitrate = computeBitrate(txAudio, txPrevAudio, "bytesSent");
        txAudioPacketRate = computeRate(txAudio, txPrevAudio, "packetsSent");
        contents += this.buildLine_("Audio Tx", txAudioCodec + ", " + InfoBox.formatBitrate_(txAudioBitrate) + ", " + InfoBox.formatPacketRate_(txAudioPacketRate));
    }
    if (rxAudio) {
        rxAudioCodec = rxAudio.stat("googCodecName");
        rxAudioBitrate = computeBitrate(rxAudio, rxPrevAudio, "bytesReceived");
        rxAudioPacketRate = computeRate(rxAudio, rxPrevAudio, "packetsReceived");
        contents += this.buildLine_("Audio Rx", rxAudioCodec + ", " + InfoBox.formatBitrate_(rxAudioBitrate) + ", " + InfoBox.formatPacketRate_(rxAudioPacketRate));
    }
    if (txVideo) {
        txVideoCodec = txVideo.stat("googCodecName");
        txVideoHeight = txVideo.stat("googFrameHeightSent");
        txVideoFps = txVideo.stat("googFrameRateSent");
        txVideoBitrate = computeBitrate(txVideo, txPrevVideo, "bytesSent");
        txVideoPacketRate = computeRate(txVideo, txPrevVideo, "packetsSent");
        contents += this.buildLine_("Video Tx", txVideoCodec + ", " + txVideoHeight.toString() + "p" + txVideoFps.toString() + ", " + InfoBox.formatBitrate_(txVideoBitrate) + ", " + InfoBox.formatPacketRate_(txVideoPacketRate));
    }
    if (rxVideo) {
        rxVideoCodec = "TODO";
        rxVideoHeight = this.remoteVideo_.videoHeight;
        rxVideoFps = rxVideo.stat("googFrameRateDecoded");
        rxVideoBitrate = computeBitrate(rxVideo, rxPrevVideo, "bytesReceived");
        rxVideoPacketRate = computeRate(rxVideo, rxPrevVideo, "packetsReceived");
        contents += this.buildLine_("Video Rx", rxVideoCodec + ", " + rxVideoHeight.toString() + "p" + rxVideoFps.toString() + ", " + InfoBox.formatBitrate_(rxVideoBitrate) + ", " + InfoBox.formatPacketRate_(rxVideoPacketRate));
    }
    return contents;
};
InfoBox.prototype.buildLine_ = function(label, value) {
    var columnWidth = 12;
    var line = "";
    if (label) {
        line += label + ":";
        while (line.length < columnWidth) {
            line += " ";
        }
        if (value) {
            line += value;
        }
    }
    line += "\n";
    return line;
};
InfoBox.formatInterval_ = function(value) {
    var result = "";
    var seconds = Math.floor(value / 1E3);
    var minutes = Math.floor(seconds / 60);
    var hours = Math.floor(minutes / 60);
    var formatTwoDigit = function(twodigit) {
        return (twodigit < 10 ? "0" : "") + twodigit.toString();
    };
    if (hours > 0) {
        result += formatTwoDigit(hours) + ":";
    }
    result += formatTwoDigit(minutes - hours * 60) + ":";
    result += formatTwoDigit(seconds - minutes * 60);
    return result;
};
InfoBox.formatMsec_ = function(value) {
    return value.toFixed(0).toString() + " ms";
};
InfoBox.formatBitrate_ = function(value) {
    if (!value) {
        return "- bps";
    }
    var suffix;
    if (value < 1E3) {
        suffix = "bps";
    } else {
        if (value < 1E6) {
            suffix = "kbps";
            value /= 1E3;
        } else {
            suffix = "Mbps";
            value /= 1E6;
        }
    }
    var str = value.toPrecision(3) + " " + suffix;
    return str;
};
InfoBox.formatPacketRate_ = function(value) {
    if (!value) {
        return "- pps";
    }
    return value.toPrecision(3) + " " + "pps";
};
var PeerConnectionClient = function(params, startTime) {
    this.params_ = params;
    this.startTime_ = startTime;
    trace("Creating RTCPeerConnnection with:\n" + "  config: '" + JSON.stringify(params.peerConnectionConfig) + "';\n" + "  constraints: '" + JSON.stringify(params.peerConnectionConstraints) + "'.");
    this.pc_ = new RTCPeerConnection(params.peerConnectionConfig, params.peerConnectionConstraints);
    this.pc_.onicecandidate = this.onIceCandidate_.bind(this);
    this.pc_.onaddstream = this.onRemoteStreamAdded_.bind(this);
    this.pc_.onremovestream = trace.bind(null, "Remote stream removed.");
    this.pc_.onsignalingstatechange = this.onSignalingStateChanged_.bind(this);
    this.pc_.oniceconnectionstatechange = this.onIceConnectionStateChanged_.bind(this);
    this.hasRemoteSdp_ = false;
    this.messageQueue_ = [];
    this.isInitiator_ = false;
    this.started_ = false;
    this.onerror = null;
    this.oniceconnectionstatechange = null;
    this.onnewicecandidate = null;
    this.onremotehangup = null;
    this.onremotesdpset = null;
    this.onremotestreamadded = null;
    this.onsignalingmessage = null;
    this.onsignalingstatechange = null;
};
PeerConnectionClient.DEFAULT_SDP_OFFER_OPTIONS_ = {offerToReceiveAudio:1, offerToReceiveVideo:1, voiceActivityDetection:false};
PeerConnectionClient.prototype.addStream = function(stream) {
    if (!this.pc_) {
        return;
    }
    this.pc_.addStream(stream);
};
PeerConnectionClient.prototype.startAsCaller = function(offerOptions) {
    if (!this.pc_) {
        return false;
    }
    if (this.started_) {
        return false;
    }
    this.isInitiator_ = true;
    this.started_ = true;
    var constraints = mergeConstraints(PeerConnectionClient.DEFAULT_SDP_OFFER_OPTIONS_, offerOptions);
    trace("Sending offer to peer, with constraints: \n'" + JSON.stringify(constraints) + "'.");
    this.pc_.createOffer(constraints).then(this.setLocalSdpAndNotify_.bind(this))["catch"](this.onError_.bind(this, "createOffer"));
    return true;
};
PeerConnectionClient.prototype.startAsCallee = function(initialMessages) {
    if (!this.pc_) {
        return false;
    }
    if (this.started_) {
        return false;
    }
    this.isInitiator_ = false;
    this.started_ = true;
    if (initialMessages && initialMessages.length > 0) {
        for (var i = 0, len = initialMessages.length;i < len;i++) {
            this.receiveSignalingMessage(initialMessages[i]);
        }
        return true;
    }
    if (this.messageQueue_.length > 0) {
        this.drainMessageQueue_();
    }
    return true;
};
PeerConnectionClient.prototype.receiveSignalingMessage = function(message) {
    var messageObj = parseJSON(message);
    if (!messageObj) {
        return;
    }
    if (this.isInitiator_ && messageObj.type === "answer" || !this.isInitiator_ && messageObj.type === "offer") {
        this.hasRemoteSdp_ = true;
        this.messageQueue_.unshift(messageObj);
    } else {
        if (messageObj.type === "candidate") {
            this.messageQueue_.push(messageObj);
        } else {
            if (messageObj.type === "bye") {
                if (this.onremotehangup) {
                    this.onremotehangup();
                }
            }
        }
    }
    this.drainMessageQueue_();
};
PeerConnectionClient.prototype.close = function() {
    if (!this.pc_) {
        return;
    }
    this.pc_.close();
    this.pc_ = null;
};
PeerConnectionClient.prototype.getPeerConnectionStates = function() {
    if (!this.pc_) {
        return null;
    }
    return {"signalingState":this.pc_.signalingState, "iceGatheringState":this.pc_.iceGatheringState, "iceConnectionState":this.pc_.iceConnectionState};
};
PeerConnectionClient.prototype.getPeerConnectionStats = function(callback) {
    if (!this.pc_) {
        return;
    }
    this.pc_.getStats(callback);
};
PeerConnectionClient.prototype.doAnswer_ = function() {
    trace("Sending answer to peer.");
    this.pc_.createAnswer().then(this.setLocalSdpAndNotify_.bind(this))["catch"](this.onError_.bind(this, "createAnswer"));
};
PeerConnectionClient.prototype.setLocalSdpAndNotify_ = function(sessionDescription) {
    sessionDescription.sdp = maybePreferAudioReceiveCodec(sessionDescription.sdp, this.params_);
    sessionDescription.sdp = maybePreferVideoReceiveCodec(sessionDescription.sdp, this.params_);
    sessionDescription.sdp = maybeSetAudioReceiveBitRate(sessionDescription.sdp, this.params_);
    sessionDescription.sdp = maybeSetVideoReceiveBitRate(sessionDescription.sdp, this.params_);
    this.pc_.setLocalDescription(sessionDescription).then(trace.bind(null, "Set session description success."))["catch"](this.onError_.bind(this, "setLocalDescription"));
    if (this.onsignalingmessage) {
        this.onsignalingmessage({sdp:sessionDescription.sdp, type:sessionDescription.type});
    }
};
PeerConnectionClient.prototype.setRemoteSdp_ = function(message) {
    message.sdp = maybeSetOpusOptions(message.sdp, this.params_);
    message.sdp = maybePreferAudioSendCodec(message.sdp, this.params_);
    message.sdp = maybePreferVideoSendCodec(message.sdp, this.params_);
    message.sdp = maybeSetAudioSendBitRate(message.sdp, this.params_);
    message.sdp = maybeSetVideoSendBitRate(message.sdp, this.params_);
    message.sdp = maybeSetVideoSendInitialBitRate(message.sdp, this.params_);
    this.pc_.setRemoteDescription(new RTCSessionDescription(message)).then(this.onSetRemoteDescriptionSuccess_.bind(this))["catch"](this.onError_.bind(this, "setRemoteDescription"));
};
PeerConnectionClient.prototype.onSetRemoteDescriptionSuccess_ = function() {
    trace("Set remote session description success.");
    var remoteStreams = this.pc_.getRemoteStreams();
    if (this.onremotesdpset) {
        this.onremotesdpset(remoteStreams.length > 0 && remoteStreams[0].getVideoTracks().length > 0);
    }
};
PeerConnectionClient.prototype.processSignalingMessage_ = function(message) {
    if (message.type === "offer" && !this.isInitiator_) {
        if (this.pc_.signalingState !== "stable") {
            trace("ERROR: remote offer received in unexpected state: " + this.pc_.signalingState);
            return;
        }
        this.setRemoteSdp_(message);
        this.doAnswer_();
    } else {
        if (message.type === "answer" && this.isInitiator_) {
            if (this.pc_.signalingState !== "have-local-offer") {
                trace("ERROR: remote answer received in unexpected state: " + this.pc_.signalingState);
                return;
            }
            this.setRemoteSdp_(message);
        } else {
            if (message.type === "candidate") {
                var candidate = new RTCIceCandidate({sdpMLineIndex:message.label, candidate:message.candidate});
                this.recordIceCandidate_("Remote", candidate);
                this.pc_.addIceCandidate(candidate).then(trace.bind(null, "Remote candidate added successfully."))["catch"](this.onError_.bind(this, "addIceCandidate"));
            } else {
                trace("WARNING: unexpected message: " + JSON.stringify(message));
            }
        }
    }
};
PeerConnectionClient.prototype.drainMessageQueue_ = function() {
    if (!this.pc_ || !this.started_ || !this.hasRemoteSdp_) {
        return;
    }
    for (var i = 0, len = this.messageQueue_.length;i < len;i++) {
        this.processSignalingMessage_(this.messageQueue_[i]);
    }
    this.messageQueue_ = [];
};
PeerConnectionClient.prototype.onIceCandidate_ = function(event) {
    if (event.candidate) {
        if (this.filterIceCandidate_(event.candidate)) {
            var message = {type:"candidate", label:event.candidate.sdpMLineIndex, id:event.candidate.sdpMid, candidate:event.candidate.candidate};
            if (this.onsignalingmessage) {
                this.onsignalingmessage(message);
            }
            this.recordIceCandidate_("Local", event.candidate);
        }
    } else {
        trace("End of candidates.");
    }
};
PeerConnectionClient.prototype.onSignalingStateChanged_ = function() {
    if (!this.pc_) {
        return;
    }
    trace("Signaling state changed to: " + this.pc_.signalingState);
    if (this.onsignalingstatechange) {
        this.onsignalingstatechange();
    }
};
PeerConnectionClient.prototype.onIceConnectionStateChanged_ = function() {
    if (!this.pc_) {
        return;
    }
    trace("ICE connection state changed to: " + this.pc_.iceConnectionState);
    if (this.pc_.iceConnectionState === "completed") {
        trace("ICE complete time: " + (window.performance.now() - this.startTime_).toFixed(0) + "ms.");
    }
    if (this.oniceconnectionstatechange) {
        this.oniceconnectionstatechange();
    }
};
PeerConnectionClient.prototype.filterIceCandidate_ = function(candidateObj) {
    var candidateStr = candidateObj.candidate;
    if (candidateStr.indexOf("tcp") !== -1) {
        return false;
    }
    if (this.params_.peerConnectionConfig.iceTransports === "relay" && iceCandidateType(candidateStr) !== "relay") {
        return false;
    }
    return true;
};
PeerConnectionClient.prototype.recordIceCandidate_ = function(location, candidateObj) {
    if (this.onnewicecandidate) {
        this.onnewicecandidate(location, candidateObj.candidate);
    }
};
PeerConnectionClient.prototype.onRemoteStreamAdded_ = function(event) {
    if (this.onremotestreamadded) {
        this.onremotestreamadded(event.stream);
    }
};
PeerConnectionClient.prototype.onError_ = function(tag, error) {
    if (this.onerror) {
        this.onerror(tag + ": " + error.toString());
    }
};
var RemoteWebSocket = function(wssUrl, wssPostUrl) {
    this.wssUrl_ = wssUrl;
    apprtc.windowPort.addMessageListener(this.handleMessage_.bind(this));
    this.sendMessage_({action:Constants.WS_ACTION, wsAction:Constants.WS_CREATE_ACTION, wssUrl:wssUrl, wssPostUrl:wssPostUrl});
    this.readyState = WebSocket.CONNECTING;
};
RemoteWebSocket.prototype.sendMessage_ = function(message) {
    apprtc.windowPort.sendMessage(message);
};
RemoteWebSocket.prototype.send = function(data) {
    if (this.readyState !== WebSocket.OPEN) {
        throw "Web socket is not in OPEN state: " + this.readyState;
    }
    this.sendMessage_({action:Constants.WS_ACTION, wsAction:Constants.WS_SEND_ACTION, data:data});
};
RemoteWebSocket.prototype.close = function() {
    if (this.readyState === WebSocket.CLOSING || this.readyState === WebSocket.CLOSED) {
        return;
    }
    this.readyState = WebSocket.CLOSING;
    this.sendMessage_({action:Constants.WS_ACTION, wsAction:Constants.WS_CLOSE_ACTION});
};
RemoteWebSocket.prototype.handleMessage_ = function(message) {
    if (message.action === Constants.WS_ACTION && message.wsAction === Constants.EVENT_ACTION) {
        if (message.wsEvent === Constants.WS_EVENT_ONOPEN) {
            this.readyState = WebSocket.OPEN;
            if (this.onopen) {
                this.onopen();
            }
        } else {
            if (message.wsEvent === Constants.WS_EVENT_ONCLOSE) {
                this.readyState = WebSocket.CLOSED;
                if (this.onclose) {
                    this.onclose(message.data);
                }
            } else {
                if (message.wsEvent === Constants.WS_EVENT_ONERROR) {
                    if (this.onerror) {
                        this.onerror(message.data);
                    }
                } else {
                    if (message.wsEvent === Constants.WS_EVENT_ONMESSAGE) {
                        if (this.onmessage) {
                            this.onmessage(message.data);
                        }
                    } else {
                        if (message.wsEvent === Constants.WS_EVENT_SENDERROR) {
                            if (this.onsenderror) {
                                this.onsenderror(message.data);
                            }
                            trace("ERROR: web socket send failed: " + message.data);
                        }
                    }
                }
            }
        }
    }
};
var RoomSelection = function(roomSelectionDiv, uiConstants, recentRoomsKey, setupCompletedCallback) {
    this.roomSelectionDiv_ = roomSelectionDiv;
    this.setupCompletedCallback_ = setupCompletedCallback;
    this.roomIdInput_ = this.roomSelectionDiv_.querySelector(uiConstants.roomSelectionInput);
    this.roomIdInputLabel_ = this.roomSelectionDiv_.querySelector(uiConstants.roomSelectionInputLabel);
    this.roomJoinButton_ = this.roomSelectionDiv_.querySelector(uiConstants.roomSelectionJoinButton);
    this.roomRandomButton_ = this.roomSelectionDiv_.querySelector(uiConstants.roomSelectionRandomButton);
    this.roomRecentList_ = this.roomSelectionDiv_.querySelector(uiConstants.roomSelectionRecentList);
    this.roomIdInput_.value = randomString(9);
    this.onRoomIdInput_();
    this.roomIdInputListener_ = this.onRoomIdInput_.bind(this);
    this.roomIdInput_.addEventListener("input", this.roomIdInputListener_, false);
    this.roomIdKeyupListener_ = this.onRoomIdKeyPress_.bind(this);
    this.roomIdInput_.addEventListener("keyup", this.roomIdKeyupListener_, false);
    this.roomRandomButtonListener_ = this.onRandomButton_.bind(this);
    this.roomRandomButton_.addEventListener("click", this.roomRandomButtonListener_, false);
    this.roomJoinButtonListener_ = this.onJoinButton_.bind(this);
    this.roomJoinButton_.addEventListener("click", this.roomJoinButtonListener_, false);
    this.onRoomSelected = null;
    this.recentlyUsedList_ = new RoomSelection.RecentlyUsedList(recentRoomsKey);
    this.startBuildingRecentRoomList_();
};
RoomSelection.matchRandomRoomPattern = function(input) {
    return input.match(/^\d{9}$/) !== null;
};
RoomSelection.prototype.removeEventListeners = function() {
    this.roomIdInput_.removeEventListener("input", this.roomIdInputListener_);
    this.roomIdInput_.removeEventListener("keyup", this.roomIdKeyupListener_);
    this.roomRandomButton_.removeEventListener("click", this.roomRandomButtonListener_);
    this.roomJoinButton_.removeEventListener("click", this.roomJoinButtonListener_);
};
RoomSelection.prototype.startBuildingRecentRoomList_ = function() {
    this.recentlyUsedList_.getRecentRooms().then(function(recentRooms) {
        this.buildRecentRoomList_(recentRooms);
        if (this.setupCompletedCallback_) {
            this.setupCompletedCallback_();
        }
    }.bind(this))["catch"](function(error) {
        trace("Error building recent rooms list: " + error.message);
    }.bind(this));
};
RoomSelection.prototype.buildRecentRoomList_ = function(recentRooms) {
    var lastChild = this.roomRecentList_.lastChild;
    while (lastChild) {
        this.roomRecentList_.removeChild(lastChild);
        lastChild = this.roomRecentList_.lastChild;
    }
    for (var i = 0;i < recentRooms.length;++i) {
        var li = document.createElement("li");
        var href = document.createElement("a");
        var linkText = document.createTextNode(recentRooms[i]);
        href.appendChild(linkText);
        href.href = location.origin + "/r/" + encodeURIComponent(recentRooms[i]);
        li.appendChild(href);
        this.roomRecentList_.appendChild(li);
        href.addEventListener("click", this.makeRecentlyUsedClickHandler_(recentRooms[i]).bind(this), false);
    }
};
RoomSelection.prototype.onRoomIdInput_ = function() {
    var room = this.roomIdInput_.value;
    var valid = room.length >= 5;
    var re = /^([a-zA-Z0-9-_]+)+$/;
    valid = valid && re.exec(room);
    if (valid) {
        this.roomJoinButton_.disabled = false;
        this.roomIdInput_.classList.remove("invalid");
        this.roomIdInputLabel_.classList.add("hidden");
    } else {
        this.roomJoinButton_.disabled = true;
        this.roomIdInput_.classList.add("invalid");
        this.roomIdInputLabel_.classList.remove("hidden");
    }
};
RoomSelection.prototype.onRoomIdKeyPress_ = function(event) {
    if (event.which !== 13 || this.roomJoinButton_.disabled) {
        return;
    }
    this.onJoinButton_();
};
RoomSelection.prototype.onRandomButton_ = function() {
    this.roomIdInput_.value = randomString(9);
    this.onRoomIdInput_();
};
RoomSelection.prototype.onJoinButton_ = function() {
    this.loadRoom_(this.roomIdInput_.value);
};
RoomSelection.prototype.makeRecentlyUsedClickHandler_ = function(roomName) {
    return function(e) {
        e.preventDefault();
        this.loadRoom_(roomName);
    };
};
RoomSelection.prototype.loadRoom_ = function(roomName) {
    this.recentlyUsedList_.pushRecentRoom(roomName);
    if (this.onRoomSelected) {
        this.onRoomSelected(roomName);
    }
};
RoomSelection.RecentlyUsedList = function(key) {
    this.LISTLENGTH_ = 10;
    this.RECENTROOMSKEY_ = key || "recentRooms";
    this.storage_ = new Storage;
};
RoomSelection.RecentlyUsedList.prototype.pushRecentRoom = function(roomId) {
    return new Promise(function(resolve, reject) {
        if (!roomId) {
            resolve();
            return;
        }
        this.getRecentRooms().then(function(recentRooms) {
            recentRooms = [roomId].concat(recentRooms);
            recentRooms = recentRooms.filter(function(value, index, self) {
                return self.indexOf(value) === index;
            });
            recentRooms = recentRooms.slice(0, this.LISTLENGTH_);
            this.storage_.setStorage(this.RECENTROOMSKEY_, JSON.stringify(recentRooms), function() {
                resolve();
            });
        }.bind(this))["catch"](function(err) {
            reject(err);
        }.bind(this));
    }.bind(this));
};
RoomSelection.RecentlyUsedList.prototype.getRecentRooms = function() {
    return new Promise(function(resolve) {
        this.storage_.getStorage(this.RECENTROOMSKEY_, function(value) {
            var recentRooms = parseJSON(value);
            if (!recentRooms) {
                recentRooms = [];
            }
            resolve(recentRooms);
        });
    }.bind(this));
};
function mergeConstraints(cons1, cons2) {
    if (!cons1 || !cons2) {
        return cons1 || cons2;
    }
    var merged = cons1;
    for (var key in cons2) {
        merged[key] = cons2[key];
    }
    return merged;
}
function iceCandidateType(candidateStr) {
    return candidateStr.split(" ")[7];
}
function formatTypePreference(pref) {
    if (webrtcDetectedBrowser === "chrome") {
        switch(pref) {
            case 0:
                return "TURN/TLS";
            case 1:
                return "TURN/TCP";
            case 2:
                return "TURN/UDP";
        }
    } else {
        if (webrtcDetectedBrowser === "firefox") {
            switch(pref) {
                case 0:
                    return "TURN/TCP";
                case 5:
                    return "TURN/UDP";
            }
        }
    }
    return "";
}
function maybeSetOpusOptions(sdp, params) {
    if (params.opusStereo === "true") {
        sdp = setCodecParam(sdp, "opus/48000", "stereo", "1");
    } else {
        if (params.opusStereo === "false") {
            sdp = removeCodecParam(sdp, "opus/48000", "stereo");
        }
    }
    if (params.opusFec === "true") {
        sdp = setCodecParam(sdp, "opus/48000", "useinbandfec", "1");
    } else {
        if (params.opusFec === "false") {
            sdp = removeCodecParam(sdp, "opus/48000", "useinbandfec");
        }
    }
    if (params.opusDtx === "true") {
        sdp = setCodecParam(sdp, "opus/48000", "usedtx", "1");
    } else {
        if (params.opusDtx === "false") {
            sdp = removeCodecParam(sdp, "opus/48000", "usedtx");
        }
    }
    if (params.opusMaxPbr) {
        sdp = setCodecParam(sdp, "opus/48000", "maxplaybackrate", params.opusMaxPbr);
    }
    return sdp;
}
function maybeSetAudioSendBitRate(sdp, params) {
    if (!params.audioSendBitrate) {
        return sdp;
    }
    trace("Prefer audio send bitrate: " + params.audioSendBitrate);
    return preferBitRate(sdp, params.audioSendBitrate, "audio");
}
function maybeSetAudioReceiveBitRate(sdp, params) {
    if (!params.audioRecvBitrate) {
        return sdp;
    }
    trace("Prefer audio receive bitrate: " + params.audioRecvBitrate);
    return preferBitRate(sdp, params.audioRecvBitrate, "audio");
}
function maybeSetVideoSendBitRate(sdp, params) {
    if (!params.videoSendBitrate) {
        return sdp;
    }
    trace("Prefer video send bitrate: " + params.videoSendBitrate);
    return preferBitRate(sdp, params.videoSendBitrate, "video");
}
function maybeSetVideoReceiveBitRate(sdp, params) {
    if (!params.videoRecvBitrate) {
        return sdp;
    }
    trace("Prefer video receive bitrate: " + params.videoRecvBitrate);
    return preferBitRate(sdp, params.videoRecvBitrate, "video");
}
function preferBitRate(sdp, bitrate, mediaType) {
    var sdpLines = sdp.split("\r\n");
    var mLineIndex = findLine(sdpLines, "m=", mediaType);
    if (mLineIndex === null) {
        trace("Failed to add bandwidth line to sdp, as no m-line found");
        return sdp;
    }
    var nextMLineIndex = findLineInRange(sdpLines, mLineIndex + 1, -1, "m=");
    if (nextMLineIndex === null) {
        nextMLineIndex = sdpLines.length;
    }
    var cLineIndex = findLineInRange(sdpLines, mLineIndex + 1, nextMLineIndex, "c=");
    if (cLineIndex === null) {
        trace("Failed to add bandwidth line to sdp, as no c-line found");
        return sdp;
    }
    var bLineIndex = findLineInRange(sdpLines, cLineIndex + 1, nextMLineIndex, "b=AS");
    if (bLineIndex) {
        sdpLines.splice(bLineIndex, 1);
    }
    var bwLine = "b=AS:" + bitrate;
    sdpLines.splice(cLineIndex + 1, 0, bwLine);
    sdp = sdpLines.join("\r\n");
    return sdp;
}
function maybeSetVideoSendInitialBitRate(sdp, params) {
    var initialBitrate = params.videoSendInitialBitrate;
    if (!initialBitrate) {
        return sdp;
    }
    var maxBitrate = initialBitrate;
    var bitrate = params.videoSendBitrate;
    if (bitrate) {
        if (initialBitrate > bitrate) {
            trace("Clamping initial bitrate to max bitrate of " + bitrate + " kbps.");
            initialBitrate = bitrate;
            params.videoSendInitialBitrate = initialBitrate;
        }
        maxBitrate = bitrate;
    }
    var sdpLines = sdp.split("\r\n");
    var mLineIndex = findLine(sdpLines, "m=", "video");
    if (mLineIndex === null) {
        trace("Failed to find video m-line");
        return sdp;
    }
    sdp = setCodecParam(sdp, "VP8/90000", "x-google-min-bitrate", params.videoSendInitialBitrate.toString());
    sdp = setCodecParam(sdp, "VP8/90000", "x-google-max-bitrate", maxBitrate.toString());
    return sdp;
}
function maybePreferAudioSendCodec(sdp, params) {
    return maybePreferCodec(sdp, "audio", "send", params.audioSendCodec);
}
function maybePreferAudioReceiveCodec(sdp, params) {
    return maybePreferCodec(sdp, "audio", "receive", params.audioRecvCodec);
}
function maybePreferVideoSendCodec(sdp, params) {
    return maybePreferCodec(sdp, "video", "send", params.videoSendCodec);
}
function maybePreferVideoReceiveCodec(sdp, params) {
    return maybePreferCodec(sdp, "video", "receive", params.videoRecvCodec);
}
function maybePreferCodec(sdp, type, dir, codec) {
    var str = type + " " + dir + " codec";
    if (!codec) {
        trace("No preference on " + str + ".");
        return sdp;
    }
    trace("Prefer " + str + ": " + codec);
    var sdpLines = sdp.split("\r\n");
    var mLineIndex = findLine(sdpLines, "m=", type);
    if (mLineIndex === null) {
        return sdp;
    }
    var payload = getCodecPayloadType(sdpLines, codec);
    if (payload) {
        sdpLines[mLineIndex] = setDefaultCodec(sdpLines[mLineIndex], payload);
    }
    sdp = sdpLines.join("\r\n");
    return sdp;
}
function setCodecParam(sdp, codec, param, value) {
    var sdpLines = sdp.split("\r\n");
    var fmtpLineIndex = findFmtpLine(sdpLines, codec);
    var fmtpObj = {};
    if (fmtpLineIndex === null) {
        var index = findLine(sdpLines, "a=rtpmap", codec);
        if (index === null) {
            return sdp;
        }
        var payload = getCodecPayloadTypeFromLine(sdpLines[index]);
        fmtpObj.pt = payload.toString();
        fmtpObj.params = {};
        fmtpObj.params[param] = value;
        sdpLines.splice(index + 1, 0, writeFmtpLine(fmtpObj));
    } else {
        fmtpObj = parseFmtpLine(sdpLines[fmtpLineIndex]);
        fmtpObj.params[param] = value;
        sdpLines[fmtpLineIndex] = writeFmtpLine(fmtpObj);
    }
    sdp = sdpLines.join("\r\n");
    return sdp;
}
function removeCodecParam(sdp, codec, param) {
    var sdpLines = sdp.split("\r\n");
    var fmtpLineIndex = findFmtpLine(sdpLines, codec);
    if (fmtpLineIndex === null) {
        return sdp;
    }
    var map = parseFmtpLine(sdpLines[fmtpLineIndex]);
    delete map.params[param];
    var newLine = writeFmtpLine(map);
    if (newLine === null) {
        sdpLines.splice(fmtpLineIndex, 1);
    } else {
        sdpLines[fmtpLineIndex] = newLine;
    }
    sdp = sdpLines.join("\r\n");
    return sdp;
}
function parseFmtpLine(fmtpLine) {
    var fmtpObj = {};
    var spacePos = fmtpLine.indexOf(" ");
    var keyValues = fmtpLine.substring(spacePos + 1).split("; ");
    var pattern = new RegExp("a=fmtp:(\\d+)");
    var result = fmtpLine.match(pattern);
    if (result && result.length === 2) {
        fmtpObj.pt = result[1];
    } else {
        return null;
    }
    var params = {};
    for (var i = 0;i < keyValues.length;++i) {
        var pair = keyValues[i].split("=");
        if (pair.length === 2) {
            params[pair[0]] = pair[1];
        }
    }
    fmtpObj.params = params;
    return fmtpObj;
}
function writeFmtpLine(fmtpObj) {
    if (!fmtpObj.hasOwnProperty("pt") || !fmtpObj.hasOwnProperty("params")) {
        return null;
    }
    var pt = fmtpObj.pt;
    var params = fmtpObj.params;
    var keyValues = [];
    var i = 0;
    for (var key in params) {
        keyValues[i] = key + "=" + params[key];
        ++i;
    }
    if (i === 0) {
        return null;
    }
    return "a=fmtp:" + pt.toString() + " " + keyValues.join("; ");
}
function findFmtpLine(sdpLines, codec) {
    var payload = getCodecPayloadType(sdpLines, codec);
    return payload ? findLine(sdpLines, "a=fmtp:" + payload.toString()) : null;
}
function findLine(sdpLines, prefix, substr) {
    return findLineInRange(sdpLines, 0, -1, prefix, substr);
}
function findLineInRange(sdpLines, startLine, endLine, prefix, substr) {
    var realEndLine = endLine !== -1 ? endLine : sdpLines.length;
    for (var i = startLine;i < realEndLine;++i) {
        if (sdpLines[i].indexOf(prefix) === 0) {
            if (!substr || sdpLines[i].toLowerCase().indexOf(substr.toLowerCase()) !== -1) {
                return i;
            }
        }
    }
    return null;
}
function getCodecPayloadType(sdpLines, codec) {
    var index = findLine(sdpLines, "a=rtpmap", codec);
    return index ? getCodecPayloadTypeFromLine(sdpLines[index]) : null;
}
function getCodecPayloadTypeFromLine(sdpLine) {
    var pattern = new RegExp("a=rtpmap:(\\d+) \\w+\\/\\d+");
    var result = sdpLine.match(pattern);
    return result && result.length === 2 ? result[1] : null;
}
function setDefaultCodec(mLine, payload) {
    var elements = mLine.split(" ");
    var newLine = elements.slice(0, 3);
    newLine.push(payload);
    for (var i = 3;i < elements.length;i++) {
        if (elements[i] !== payload) {
            newLine.push(elements[i]);
        }
    }
    return newLine.join(" ");
}
;var SignalingChannel = function(wssUrl, wssPostUrl) {
    this.wssUrl_ = wssUrl;
    this.wssPostUrl_ = wssPostUrl;
    this.roomId_ = null;
    this.clientId_ = null;
    this.websocket_ = null;
    this.registered_ = false;
    this.onerror = null;
    this.onmessage = null;
};
SignalingChannel.prototype.open = function() {
    if (this.websocket_) {
        trace("ERROR: SignalingChannel has already opened.");
        return;
    }
    trace("Opening signaling channel.");
    return new Promise(function(resolve, reject) {
        if (isChromeApp()) {
            this.websocket_ = new RemoteWebSocket(this.wssUrl_, this.wssPostUrl_);
        } else {
            this.websocket_ = new WebSocket(this.wssUrl_);
        }
        this.websocket_.onopen = function() {
            trace("Signaling channel opened.");
            this.websocket_.onerror = function() {
                trace("Signaling channel error.");
            };
            this.websocket_.onclose = function(event) {
                trace("Channel closed with code:" + event.code + " reason:" + event.reason);
                this.websocket_ = null;
                this.registered_ = false;
            };
            if (this.clientId_ && this.roomId_) {
                this.register(this.roomId_, this.clientId_);
            }
            resolve();
        }.bind(this);
        this.websocket_.onmessage = function(event) {
            trace("WSS->C: " + event.data);
            var message = parseJSON(event.data);
            if (!message) {
                trace("Failed to parse WSS message: " + event.data);
                return;
            }
            if (message.error) {
                trace("Signaling server error message: " + message.error);
                return;
            }
            this.onmessage(message.msg);
        }.bind(this);
        this.websocket_.onerror = function() {
            reject(Error("WebSocket error."));
        };
    }.bind(this));
};
SignalingChannel.prototype.register = function(roomId, clientId) {
    if (this.registered_) {
        trace("ERROR: SignalingChannel has already registered.");
        return;
    }
    this.roomId_ = roomId;
    this.clientId_ = clientId;
    if (!this.roomId_) {
        trace("ERROR: missing roomId.");
    }
    if (!this.clientId_) {
        trace("ERROR: missing clientId.");
    }
    if (!this.websocket_ || this.websocket_.readyState !== WebSocket.OPEN) {
        trace("WebSocket not open yet; saving the IDs to register later.");
        return;
    }
    trace("Registering signaling channel.");
    var registerMessage = {cmd:"register", roomid:this.roomId_, clientid:this.clientId_};
    this.websocket_.send(JSON.stringify(registerMessage));
    this.registered_ = true;
    trace("Signaling channel registered.");
};
SignalingChannel.prototype.close = function(async) {
    if (this.websocket_) {
        this.websocket_.close();
        this.websocket_ = null;
    }
    if (!this.clientId_ || !this.roomId_) {
        return;
    }
    var path = this.getWssPostUrl();
    return sendUrlRequest("DELETE", path, async)["catch"](function(error) {
        trace("Error deleting web socket connection: " + error.message);
    }.bind(this)).then(function() {
        this.clientId_ = null;
        this.roomId_ = null;
        this.registered_ = false;
    }.bind(this));
};
SignalingChannel.prototype.send = function(message) {
    if (!this.roomId_ || !this.clientId_) {
        trace("ERROR: SignalingChannel has not registered.");
        return;
    }
    trace("C->WSS: " + message);
    var wssMessage = {cmd:"send", msg:message};
    var msgString = JSON.stringify(wssMessage);
    if (this.websocket_ && this.websocket_.readyState === WebSocket.OPEN) {
        this.websocket_.send(msgString);
    } else {
        var path = this.getWssPostUrl();
        var xhr = new XMLHttpRequest;
        xhr.open("POST", path, true);
        xhr.send(wssMessage.msg);
    }
};
SignalingChannel.prototype.getWssPostUrl = function() {
    return this.wssPostUrl_ + "/" + this.roomId_ + "/" + this.clientId_;
};
function extractStatAsInt(stats, statObj, statName) {
    var str = extractStat(stats, statObj, statName);
    if (str) {
        var val = parseInt(str);
        if (val !== -1) {
            return val;
        }
    }
    return null;
}
function extractStat(stats, statObj, statName) {
    var report = getStatsReport(stats, statObj, statName);
    if (report && report.names().indexOf(statName) !== -1) {
        return report.stat(statName);
    }
    return null;
}
function getStatsReport(stats, statObj, statName, statVal) {
    if (stats) {
        for (var i = 0;i < stats.length;++i) {
            var report = stats[i];
            if (report.type === statObj) {
                var found = true;
                if (statName) {
                    var val = statName === "id" ? report.id : report.stat(statName);
                    found = statVal !== undefined ? val === statVal : val;
                }
                if (found) {
                    return report;
                }
            }
        }
    }
}
function computeRate(newReport, oldReport, statName) {
    var newVal = newReport.stat(statName);
    var oldVal = oldReport ? oldReport.stat(statName) : null;
    if (newVal === null || oldVal === null) {
        return null;
    }
    return (newVal - oldVal) / (newReport.timestamp - oldReport.timestamp) * 1E3;
}
function computeBitrate(newReport, oldReport, statName) {
    return computeRate(newReport, oldReport, statName) * 8;
}
function computeE2EDelay(captureStart, remoteVideoCurrentTime) {
    if (!captureStart) {
        return null;
    }
    var nowNTP = Date.now() + 22089888E5;
    return nowNTP - captureStart - remoteVideoCurrentTime * 1E3;
}
;var Storage = function() {
};
Storage.prototype.getStorage = function(key, callback) {
    if (isChromeApp()) {
        chrome.storage.local.get(key, function(values) {
            if (callback) {
                window.setTimeout(function() {
                    callback(values[key]);
                }, 0);
            }
        });
    } else {
        var value = localStorage.getItem(key);
        if (callback) {
            window.setTimeout(function() {
                callback(value);
            }, 0);
        }
    }
};
Storage.prototype.setStorage = function(key, value, callback) {
    if (isChromeApp()) {
        var data = {};
        data[key] = value;
        chrome.storage.local.set(data, callback);
    } else {
        localStorage.setItem(key, value);
        if (callback) {
            window.setTimeout(callback, 0);
        }
    }
};
function $(selector) {
    return document.querySelector(selector);
}
function queryStringToDictionary(queryString) {
    var pairs = queryString.slice(1).split("&");
    var result = {};
    pairs.forEach(function(pair) {
        if (pair) {
            pair = pair.split("=");
            if (pair[0]) {
                result[pair[0]] = decodeURIComponent(pair[1] || "");
            }
        }
    });
    return result;
}
function sendAsyncUrlRequest(method, url, body) {
    return sendUrlRequest(method, url, true, body);
}
function sendUrlRequest(method, url, async, body) {
    return new Promise(function(resolve, reject) {
        var xhr;
        var reportResults = function() {
            if (xhr.status !== 200) {
                reject(Error("Status=" + xhr.status + ", response=" + xhr.responseText));
                return;
            }
            resolve(xhr.responseText);
        };
        xhr = new XMLHttpRequest;
        if (async) {
            xhr.onreadystatechange = function() {
                if (xhr.readyState !== 4) {
                    return;
                }
                reportResults();
            };
        }
        xhr.open(method, url, async);
        xhr.send(body);
        if (!async) {
            reportResults();
        }
    });
}
function requestIceServers(iceServerRequestUrl, iceTransports) {
    return new Promise(function(resolve, reject) {
        sendAsyncUrlRequest("POST", iceServerRequestUrl).then(function(response) {
            var iceServerRequestResponse = parseJSON(response);
            if (!iceServerRequestResponse) {
                reject(Error("Error parsing response JSON: " + response));
                return;
            }
            if (iceTransports !== "") {
                filterIceServersUrls(iceServerRequestResponse, iceTransports);
            }
            trace("Retrieved ICE server information.");
            resolve(iceServerRequestResponse.iceServers);
        })["catch"](function(error) {
            reject(Error("ICE server request error: " + error.message));
            return;
        });
    });
}
function parseJSON(json) {
    try {
        return JSON.parse(json);
    } catch (e) {
        trace("Error parsing json: " + json);
    }
    return null;
}
function filterIceServersUrls(config, protocol) {
    var transport = "transport=" + protocol;
    var newIceServers = [];
    for (var i = 0;i < config.iceServers.length;++i) {
        var iceServer = config.iceServers[i];
        var newUrls = [];
        for (var j = 0;j < iceServer.urls.length;++j) {
            var url = iceServer.urls[j];
            if (url.indexOf(transport) !== -1) {
                newUrls.push(url);
            } else {
                if (url.indexOf("?transport=") === -1) {
                    newUrls.push(url + "?" + transport);
                }
            }
        }
        if (newUrls.length !== 0) {
            iceServer.urls = newUrls;
            newIceServers.push(iceServer);
        }
    }
    config.iceServers = newIceServers;
}
function setUpFullScreen() {
    if (isChromeApp()) {
        document.cancelFullScreen = function() {
            chrome.app.window.current().restore();
        };
    } else {
        document.cancelFullScreen = document.webkitCancelFullScreen || document.mozCancelFullScreen || document.cancelFullScreen;
    }
    if (isChromeApp()) {
        document.body.requestFullScreen = function() {
            chrome.app.window.current().fullscreen();
        };
    } else {
        document.body.requestFullScreen = document.body.webkitRequestFullScreen || document.body.mozRequestFullScreen || document.body.requestFullScreen;
    }
    document.onfullscreenchange = document.onfullscreenchange || document.onwebkitfullscreenchange || document.onmozfullscreenchange;
}
function isFullScreen() {
    if (isChromeApp()) {
        return chrome.app.window.current().isFullscreen();
    }
    return !!(document.webkitIsFullScreen || document.mozFullScreen || document.isFullScreen);
}
function fullScreenElement() {
    return document.webkitFullScreenElement || document.webkitCurrentFullScreenElement || document.mozFullScreenElement || document.fullScreenElement;
}
function randomString(strLength) {
    var result = [];
    strLength = strLength || 5;
    var charSet = "0123456789";
    while (strLength--) {
        result.push(charSet.charAt(Math.floor(Math.random() * charSet.length)));
    }
    return result.join("");
}
function isChromeApp() {
    return typeof chrome !== "undefined" && typeof chrome.storage !== "undefined" && typeof chrome.storage.local !== "undefined";
}
;var apprtc = apprtc || {};
apprtc.windowPort = apprtc.windowPort || {};
(function() {
    var port_;
    apprtc.windowPort.sendMessage = function(message) {
        var port = getPort_();
        try {
            port.postMessage(message);
        } catch (ex) {
            trace("Error sending message via port: " + ex);
        }
    };
    apprtc.windowPort.addMessageListener = function(listener) {
        var port = getPort_();
        port.onMessage.addListener(listener);
    };
    var getPort_ = function() {
        if (!port_) {
            port_ = chrome.runtime.connect();
        }
        return port_;
    };
})();
