/**
 * Created by godsong on 16/3/21.
 */
import EventEmitter from "./EventEmitter";
let _toString = Object.prototype.toString;
function _isObject(target) {
    return _toString.call(target) === '[object Object]';
}
function _merge(src) {
    if (typeof arguments[arguments.length - 1] === 'boolean') {
        var deepClone = arguments[arguments.length - 1], len = 1;
    }
    else {
        deepClone = false;
        len = 0;
    }
    for (let i = 1; i < arguments.length - len; i++) {
        let target = arguments[i];
        for (let key in target) {
            if (target.hasOwnProperty(key)) {
                let obj = target[key];
                if (obj instanceof Array && deepClone) {
                    _merge(src[key] = [], obj);
                }
                else if (_isObject(obj) && deepClone) {
                    _merge(src[key] = {}, obj);
                }
                else {
                    src[key] = obj;
                }
            }
        }
    }
    return src;
}
class ConfigManager extends EventEmitter {
    constructor() {
        super();
        this._config = {};
        this._defaultConfig = {};
    }

    get(name) {
        return this._config[name];
    }

    set(name, conf) {
        if (_isObject(conf)) {
            this._config[name] = _merge({}, this._defaultConfig, conf)
        }
        else {
            this._config[name] = conf;
        }
    }

    setDefaultConfig(name, conf) {
        this._defaultConfig[name] = conf;
        if (_isObject(conf)) {
            this._config[name] = _merge({}, conf)
        }
        else {
            this._config[name] = conf;
        }
    }

    init(conf) {
        this._config = _merge({}, this._config, conf);
    }

}
//单例的ConfigManager
export default new ConfigManager();