/**
 * 枚举值定义
 * @author gaosong
 */

/**
 * EndReason 通话结束的原因枚举
 * 并且提供枚举name到枚举值的转换
 * */
class EnumItem{
    constructor(name,code,value){
        this.name=name;
        this.code=code;
        this.value=value;
    }
    valueOf(){
        return this.value;
    }
    is(enumValues){
        return (this.value&enumValues)==this.value;
    }
    has(enumValue){
        return (this.value&enumValue)==enumValue;
    }
    not(enumValues){
        return (this.value&enumValues)==0;
    }
}
class Enum{
    constructor(enumDefination) {
        this._size=0;
        for (let key in enumDefination) {
            if (enumDefination.hasOwnProperty(key)) {
                this[key]=new EnumItem(key.charAt(0).toLocaleLowerCase() + key.slice(1),enumDefination[key],Math.pow(2,this._size++));
            }
        }
    }
    transFromName(name) {
        return this[name.charAt(0).toUpperCase() + name.slice(1)];
    }
    transFromCode(code){
        for(let k in this){
            if(this.hasOwnProperty(k)&&k!='_size'){
                if(this[k].code==code){
                    return this[k];
                }
            }
        }
    }
    mix(value){
        let name='';
        for(let k in this){
            if(this.hasOwnProperty(k)&&k!='_size'&&this[k].is(value)){
                    name+=this[k].name+'|';
            }
        }
        return new EnumItem(name.slice(0,-1),value,value);
    }
}

//大于0 是正常退出,小于0是异常退出
export const EndReason = new Enum({
    ThisHangup: 0,
    ThisReject: 1,
    ThatHangup: 2,
    ThatReject: 3,
    ThatOffline: 4,
    ThatBusy: 5,
    ThisRecall: 6,
    ThatRecall: -1,
    ThatError:-2,
    Failed: -3,
    MediaError: -4,
    AnswerError: -5,
    OfferError: -6,
    RemoteSDPError: -7,
    LocalSDPError: -8,
    SignalError: -14,
    SocketError: -15,
    Timeout: -16


});
window.ER=EndReason;
/**
 * 呼叫状态枚举
 * */
export const CallStatus = {
    OK: 0,
    ONLINE_BUSY: 1,
    OFFLINE: 2,
    SERVER_ERROR: 3,
    REJECT: 4,
    UNKNOWN_STATUS: 5,
    ACCEPT: 6,
    IOS_ONLINE:7

};
//呼叫类型
export const CallType = {
    CoupleSession: 1,//双方通话
    MultiSession: 2,//多人通话
    AutomaticSession: 3,//对方自动接听
    CloseSession: 0//结束通话
};