/**
 * Created by godsong on 16/3/21.
 */

let _artcSid;
let _rQuote = /"/g;
import Logger from "./Logger";
var _ua = function _uaDetect() {
    var UA = {};
    var match = navigator.userAgent.match(/(chrome|360SE|se 2\.X|UBrowser|QQBrowser|Version|Firefox)(\/\d+\.\d+)?/gi);
    if (match) {
        if (match.length == 2) {
            var split = match[1].split('/');
            UA.name = split[0];
            UA.version = (split[1] || 'N/A') + '(' + match[0] + ')';
            if (match[0].indexOf('Chrome') != -1) {
                UA.ChromeVersion = +match[0].split('/')[1];
            }
        }
        else {
            split = match[0].split('/');
            UA.name = split[0].replace('Version', 'Safari');
            UA.version = split[1];
            if (UA.name == 'Chrome') {
                UA.ChromeVersion = +UA.version;
            }
        }
        match = /Mac|Windows|Android|iPhone|iPad/i.exec(navigator.userAgent);
        UA.platform = match ? match[0] : 'unknown';
        UA.display = UA.name + '/' + UA.version + ' on ' + UA.platform;
    }
    else {
        UA.display = navigator.userAgent;
    }
    return UA;
}();
let logger = new Logger('artc', 1600, 300);
let tagLogger = new Logger('artc_tag', 1600, 300);
let Monitor = {
    UA: _ua,
    log: function (text, data) {
        if (data === undefined) {
            logger.trace(text);
        }
        else {
            logger.trace(text, data);
        }
    },
    addTag(tag, data){
        let tagBody = {
            tag: tag,
            data: data,
            time: new Date(),
            sid: _artcSid
        };
        tagLogger.reportData(tagBody);
    },
    setReporter(report){
        logger.setReporter(function (data) {
            report('_$_(' + JSON.stringify(data) + ',"' + _artcSid + '");');
        })
    },
    setTagReporter(report){
        tagLogger.setReporter(function (data) {
            report('_$$_(' + JSON.stringify(data) + ');');
        })
    }
};

void function init() {

    if (!sessionStorage.getItem('artc_sid')) {
        setTimeout(function () {//timeout是为了增加时间戳的不确定性 降低uid冲突几率
            let sid = new Date().getTime().toString(36) + (Math.random() * 1679615 | 0).toString(36);
            sessionStorage.setItem('artc_sid', sid);
            _artcSid = sid;
            Monitor.log('>>>>>>' + sid + '@' + _ua.display);
        })
    }
    else {
        _artcSid = sessionStorage.getItem('artc_sid');
        Monitor.log('>>>>>>>>>>>');
    }


}();
window.onbeforeunload = function () {
};
export default Monitor;

