/**
 * Created by yuchunbo on 2016/1/14.
 */


const SignalTypeValue = {
    1001: ['CS_REQ_CALL', 'rtcReqCall'],  // 主叫呼叫被叫，将请求提交给服务器
    1002: ['CS_RES_CALL', 'rtcResCall'],  // 针对CS_REQ_CALL信令，服务端给主叫的响应
    1003: ['CS_PUSH_ROOM', 'rtcPushRoomForCaller'], // 服务端给主叫下线房间等相关信息
    1010: ['CS_PUSH_CALL', 'rtcPushCall'],    // 服务端通知被叫用户，有人呼叫他
    1011: ['CS_RES_ACCEPT', 'rtcResAccept'],  // 被叫针对主叫的呼叫，被叫给服务端的响应
    1020: ['CS_REQ_LEAVE_ROOM', 'rtcReqLeaveRoom'],   // 离开房间
    1021: ['CS_BROADCAST_LEAVE_ROOM', 'rtcBroadcastLeave'], // 将某个用户离开房间的情况，服务端广播给房间中的其他人
    1030: ['CS_REQ_HEART_BEAT', 'rtcReqHeartBeat'], // 客户端与服务端的心跳信令
    1040: ['CS_REQ_SDP', 'rtcReqSdp'], // 上传sdp到服务端
    1041: ['CS_PUSH_SDP', 'rtcPushSdp'], // 服务端将某人上传的sdp广播给房间中的其他人
    1050: ['CS_REQ_CANDIDATE', 'rtcReqCandidate'], // 上传candidate到服务端
    1051: ['CS_PUSH_CANDIDATE', 'rtcPushCandidate'], // 服务端将某人上传的candidate广播给房间中的其他人
    1060: ['CS_REQ_DATA', 'rtcReqData'], // 发送数据到服务端，服务端广播给房间中的其他人
    1061: ['CS_PUSH_DATA', 'rtcPushData'], // 服务端将某人上传的数据广播给房间中的其他人
    1080: ['CS_PUSH_REQ_USER_STATUS', 'rtcPushReqUserStatus'], // 服务端向客户端查询状态
    1081: ['CS_PUSH_RES_USER_STATUS', 'rtcPushResUserStatus'], // 客户端针对CS_PUSH_REQ_USER_STATUS信令的响应
    9000: ['CS_RES_ERROR_REQUEST_FORMAT', ''], // 信令格式错误
    9001: ['CS_RES_ERROR_SYSTEM', ''], // 信令服务端系统错误
    9004: ['CS_RES_ERROR_SYSTEM', ''],
    9003: ['CS_RES_ERROR_SYSTEM', ''],
    9002: ['CS_RES_ERROR_BUSINESS', ''] // 信令服务端业务错误

    // 8001:['ALIJK_ERROR_USERID','']  // 没取到userid
};

let SignalType = {
    //把信令名转换成信令码
    methodToCode: function (method) {
        for (let key in SignalTypeValue) {
            if (SignalTypeValue.hasOwnProperty(key)&&SignalTypeValue[key][0] == method) {
                return key;
            }
        }
        return '';
    },

    //把信令码转换成信令名
    codeToMethod: function (code) {
        return SignalTypeValue[code][0];
    },

    //通过信令码获取信息体包名
    getPackName: function (code) {
        return SignalTypeValue[code] ? SignalTypeValue[code][1] : '';
    }
}

module.exports = SignalType;
/*typedef NS_ENUM(NSInteger, ARDAppClientState) {
 STATUS_NONE,
 STATUS_CALLING,
 STATUS_RECEIVING,       //
 STATUS_CONNECTING,      //call accepted, not connected yet
 STATUS_CONNECTED,       //ICE connected
 STATUS_DISCONNECTED,    //ICE disconnected
 };*/

/*
 typedef NS_ENUM(NSInteger) {
 NO_ERROR,
 iOS_INITIALIZE_ERROR,
 ICE_FAILED_NO_RELAY_ADDRESS,//ICE 交互式连接建立（Interactive Connectivity Establishment）
 ICE_FAILED_TIME_OUT,
 STREAM_ERROR,
 MULTIPLE_SDP_ERROR,//SDP 协商信息  自己和对方能用什么视频编码解码  找到一种共同的方式
 SDP_CREATE_ERROR,
 SDP_SET_ERROR,
 CAMERA_OPEN_ERROR,
 NETWORK_ERROR,
 DEVICE_OFFLINE,
 PARTERNER_BUSY,
 PARTERNER_DECLINE,
 ROOM_SERVER_ERROR,
 SIGNAL_DATA_INVALID,
 SIGNAL_CHANNEL_ERROR,
 TIME_OUT_ERROR,
 NOT_LAST_LOGIN_DEVICE,
 AP_CS_RES_ERROR_REQUEST_FORMAT = 9000,
 AP_CS_RES_ERROR_SYSTEM,
 GENERAL_ERROR
 }ARTCErrorCode;*/
