/**
 * Created by yuchunbo on 2016/1/8.
 */
var webpack = require('webpack');
var path = require('path');
var buildPath = path.resolve(__dirname, 'build');
var nodeModulesPath = path.resolve(__dirname, 'node_modules');
//var TransferWebpackPlugin = require('transfer-webpack-plugin');

var config = {
    entry: [path.join(__dirname, '/src/artc.js')],
    resolve: {
        //When require, do not have to add these extensions to file's name
        extensions: ["", ".js", ".jsx"]
        //node_modules: ["web_modules", "node_modules"]  (Default Settings)
    },
    //Render source-map file for final build
    // devtool: 'source-map'
    devtool: 'eval',
    //output config
    output: {
        path: buildPath,    //Path of output file
        filename: 'artc.min.js'  //Name of output file
    },
    plugins: [
        //Minify the bundle
        new webpack.optimize.UglifyJsPlugin({
            compress: {
                //supresses warnings, usually from module minification
                warnings: false,
            }
        }),
        //Allows error warnings but does not stop compiling. Will remove when eslint is added
        new webpack.NoErrorsPlugin(),
        //Transfer Files
        /*new TransferWebpackPlugin([
            {from: 'www'}
        ], path.resolve(__dirname,"src"))*/
    ],
    module: {
        loaders:[
            { test: /\.css$/, loader: 'style-loader!css-loader' },
            // { test: /\.js[x]?$/, exclude: /node_modules/, loader: 'babel-loader?presets[]=es2015&presets[]=react' },
            { test: /\.js[x]?$/, exclude: /node_modules/, loader: 'babel-loader?optional=runtime&stage=0' },
        ]
    }
};

module.exports = config;